#ifndef __MPEGcodec_H__
#define __MPEGcodec_H__
#include <videoloader.h>
#include <MPEG.h>

#define NAME "MPEG-1 File loader"
#define VERSION "0.1"
#define COPYRIGHT "Copyright (C) Ruben Lopez Gomez"
#define DESCRIPTION "A Plug-in that loads all MPEG-1 files"

class MPEGcodec: public VideoLoader {
private:
    SDL_Surface *surf;
    MPEG *mpeg;
    SDL_mutex *mutex;
    int width;
    int height;
    int _size;
public:
    MPEGcodec() { mpeg=NULL;surf=NULL;width=0;height=0; }
    Image *read(int position);
    int size() { return _size; }

    bool canLoad(const char *filename);
    char* getLoaderName() { return NAME; }
    char* getLoaderVersion() { return VERSION; }
    char* getLoaderCopyright() { return COPYRIGHT; }
    char**getLoaderAuthors();
    Prototype *clone() { return new MPEGcodec(); }

    char* getLoaderDescription() {return DESCRIPTION;}
    void haveFileName();
};

#endif
