#include <stdio.h>
#include <stdlib.h>
#include "ppmcodec.h"

static char *AUTHORS[]={
    "Ruben Lopez Gomez",
    NULL
};

static Image *readppm(const char *file) {
    FILE *f=fopen(file,"r");
    char buffer[256];
    int w,h;
    fgets(buffer,254,f);
    do {
	fgets(buffer,254,f);
    } while (buffer[0]=='#');
    sscanf(buffer,"%d %d",&w,&h);
    fgets(buffer,254,f);
    Image *im=new Image(w,h);
    Pixel *position=im->frameBuffer();
    for (int i=0;i<w*h;i++) {
	fread(position, 1, 3, f);
	position->a=0xFF;
	position++;
    }
    fclose(f);
    return im;
}

char** PPM::getLoaderAuthors() {
    return AUTHORS;
}

Image * PPM::read(int position) {
    return readppm(filename);
}

#define END ".ppm"

bool PPM::canLoad(const char *filename) {
    return (strstr(filename,END) == filename+strlen(filename)-strlen(END));
}

// Instaling this input codec automatically when dinamic loaded.
extern "C" {

    class proxy {
    public:
	proxy() {
	    register_video_loader(new PPM());
	}
    };

    proxy filter;
}
