// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <gnome.h>
#include "config.h"

gboolean
on_ucbmpeg_config_delete_event         (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        Config          *conf)
{
    delete conf;
    return TRUE;
}


void
on_ok_config_clicked                   (GtkButton       *button,
                                        Config          *conf)
{

}


void
on_cancel_config_clicked               (GtkButton       *button,
                                        Config          *conf)
{
    delete conf;
}


GtkWidget*
create_ucbmpeg_config (Config *v)
{
  GtkWidget *ucbmpeg_config;
  GtkWidget *frame35;
  GtkWidget *vbox;
  GtkWidget *hbox14;
  GtkWidget *label16;
  GtkWidget *frame_pattern;
  GtkWidget *hbox16;
  GtkWidget *frame36;
  GtkWidget *frame37;
  GtkWidget *table3;
  GtkWidget *label17;
  GtkWidget *label18;
  GtkObject *gop_size_adj;
  GtkWidget *gop_size;
  GtkObject *slices_per_frame_adj;
  GtkWidget *slices_per_frame;
  GtkWidget *hbox15;
  GtkWidget *frame38;
  GtkWidget *frame40;
  GtkWidget *table4;
  GtkWidget *label19;
  GtkWidget *label20;
  GtkWidget *label21;
  GtkObject *iq_scale_adj;
  GtkWidget *iq_scale;
  GtkObject *pq_scale_adj;
  GtkWidget *pq_scale;
  GtkObject *bq_scale_adj;
  GtkWidget *bq_scale;
  GtkWidget *frame39;
  GtkWidget *frame41;
  GtkWidget *table5;
  GtkWidget *label22;
  GtkWidget *label23;
  GtkWidget *optionmenu1;
  GtkWidget *optionmenu1_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *hbox19;
  GtkObject *search_range_low_adj;
  GtkWidget *search_range_low;
  GtkWidget *label27;
  GtkObject *search_range_high_adj;
  GtkWidget *search_range_high;
  GtkWidget *hbox17;
  GtkWidget *frame42;
  GtkWidget *frame43;
  GtkWidget *table7;
  GtkWidget *label24;
  GtkWidget *label25;
  GtkWidget *p_search_algorithm;
  GtkWidget *p_search_algorithm_menu;
  GtkWidget *b_search_algorithm;
  GtkWidget *b_search_algorithm_menu;
  GtkWidget *hbox18;
  GtkWidget *label26;
  GtkWidget *reference_frame_type;
  GtkWidget *reference_frame_type_menu;
  GtkWidget *hseparator1;
  GtkWidget *hbox20;
  GtkWidget *ok_config;
  GtkWidget *cancel_config;

  ucbmpeg_config = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (ucbmpeg_config), "ucbmpeg_config", ucbmpeg_config);
  gtk_window_set_title (GTK_WINDOW (ucbmpeg_config), _("UCBMPEG Codec Configuration"));

  frame35 = gtk_frame_new (NULL);
  gtk_widget_ref (frame35);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "frame35", frame35,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame35);
  gtk_container_add (GTK_CONTAINER (ucbmpeg_config), frame35);
  gtk_container_set_border_width (GTK_CONTAINER (frame35), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame35), GTK_SHADOW_NONE);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "vbox", vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (frame35), vbox);

  hbox14 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox14);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "hbox14", hbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox14);
  gtk_box_pack_start (GTK_BOX (vbox), hbox14, FALSE, TRUE, 3);
  gtk_container_set_border_width (GTK_CONTAINER (hbox14), 3);

  label16 = gtk_label_new (_("Frame pattern:"));
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_box_pack_start (GTK_BOX (hbox14), label16, FALSE, FALSE, 3);

  frame_pattern = gtk_entry_new ();
  gtk_widget_ref (frame_pattern);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "frame_pattern", frame_pattern,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_pattern);
  gtk_box_pack_start (GTK_BOX (hbox14), frame_pattern, TRUE, TRUE, 3);
  gtk_entry_set_text (GTK_ENTRY (frame_pattern), _("I"));

  hbox16 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox16);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "hbox16", hbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox16);
  gtk_box_pack_start (GTK_BOX (vbox), hbox16, FALSE, TRUE, 3);

  frame36 = gtk_frame_new (_("General"));
  gtk_widget_ref (frame36);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "frame36", frame36,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame36);
  gtk_box_pack_start (GTK_BOX (hbox16), frame36, TRUE, TRUE, 3);
  gtk_container_set_border_width (GTK_CONTAINER (frame36), 3);

  frame37 = gtk_frame_new (NULL);
  gtk_widget_ref (frame37);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "frame37", frame37,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame37);
  gtk_container_add (GTK_CONTAINER (frame36), frame37);
  gtk_container_set_border_width (GTK_CONTAINER (frame37), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame37), GTK_SHADOW_NONE);

  table3 = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (table3);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "table3", table3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table3);
  gtk_container_add (GTK_CONTAINER (frame37), table3);

  label17 = gtk_label_new (_("GOP Size:"));
  gtk_widget_ref (label17);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "label17", label17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label17);
  gtk_table_attach (GTK_TABLE (table3), label17, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 3, 4);
  gtk_label_set_justify (GTK_LABEL (label17), GTK_JUSTIFY_LEFT);

  label18 = gtk_label_new (_("Slices per frame:"));
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_table_attach (GTK_TABLE (table3), label18, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 3, 4);
  gtk_label_set_justify (GTK_LABEL (label18), GTK_JUSTIFY_LEFT);

  gop_size_adj = gtk_adjustment_new (30, 0, 100, 1, 10, 10);
  gop_size = gtk_spin_button_new (GTK_ADJUSTMENT (gop_size_adj), 1, 0);
  gtk_widget_ref (gop_size);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "gop_size", gop_size,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (gop_size);
  gtk_table_attach (GTK_TABLE (table3), gop_size, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 3, 3);

  slices_per_frame_adj = gtk_adjustment_new (1, 0, 100, 1, 10, 10);
  slices_per_frame = gtk_spin_button_new (GTK_ADJUSTMENT (slices_per_frame_adj), 1, 0);
  gtk_widget_ref (slices_per_frame);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "slices_per_frame", slices_per_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (slices_per_frame);
  gtk_table_attach (GTK_TABLE (table3), slices_per_frame, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 3, 3);

  hbox15 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox15);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "hbox15", hbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox15);
  gtk_box_pack_start (GTK_BOX (vbox), hbox15, FALSE, TRUE, 3);
  gtk_container_set_border_width (GTK_CONTAINER (hbox15), 3);

  frame38 = gtk_frame_new (_("Scale"));
  gtk_widget_ref (frame38);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "frame38", frame38,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame38);
  gtk_box_pack_start (GTK_BOX (hbox15), frame38, TRUE, TRUE, 3);

  frame40 = gtk_frame_new (NULL);
  gtk_widget_ref (frame40);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "frame40", frame40,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame40);
  gtk_container_add (GTK_CONTAINER (frame38), frame40);
  gtk_container_set_border_width (GTK_CONTAINER (frame40), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame40), GTK_SHADOW_NONE);

  table4 = gtk_table_new (3, 2, FALSE);
  gtk_widget_ref (table4);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "table4", table4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table4);
  gtk_container_add (GTK_CONTAINER (frame40), table4);

  label19 = gtk_label_new (_("IQ Scale:"));
  gtk_widget_ref (label19);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "label19", label19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label19);
  gtk_table_attach (GTK_TABLE (table4), label19, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 3, 3);
  gtk_label_set_justify (GTK_LABEL (label19), GTK_JUSTIFY_LEFT);

  label20 = gtk_label_new (_("PQ Scale:"));
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label20);
  gtk_table_attach (GTK_TABLE (table4), label20, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 3, 3);
  gtk_label_set_justify (GTK_LABEL (label20), GTK_JUSTIFY_LEFT);

  label21 = gtk_label_new (_("BQ Scale:"));
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_table_attach (GTK_TABLE (table4), label21, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 3, 3);
  gtk_label_set_justify (GTK_LABEL (label21), GTK_JUSTIFY_LEFT);

  iq_scale_adj = gtk_adjustment_new (8, 0, 100, 1, 10, 10);
  iq_scale = gtk_spin_button_new (GTK_ADJUSTMENT (iq_scale_adj), 1, 0);
  gtk_widget_ref (iq_scale);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "iq_scale", iq_scale,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (iq_scale);
  gtk_table_attach (GTK_TABLE (table4), iq_scale, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  pq_scale_adj = gtk_adjustment_new (10, 0, 100, 1, 10, 10);
  pq_scale = gtk_spin_button_new (GTK_ADJUSTMENT (pq_scale_adj), 1, 0);
  gtk_widget_ref (pq_scale);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "pq_scale", pq_scale,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pq_scale);
  gtk_table_attach (GTK_TABLE (table4), pq_scale, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  bq_scale_adj = gtk_adjustment_new (25, 0, 100, 1, 10, 10);
  bq_scale = gtk_spin_button_new (GTK_ADJUSTMENT (bq_scale_adj), 1, 0);
  gtk_widget_ref (bq_scale);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "bq_scale", bq_scale,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bq_scale);
  gtk_table_attach (GTK_TABLE (table4), bq_scale, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  frame39 = gtk_frame_new (_("Search"));
  gtk_widget_ref (frame39);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "frame39", frame39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame39);
  gtk_box_pack_start (GTK_BOX (hbox15), frame39, TRUE, TRUE, 3);

  frame41 = gtk_frame_new (NULL);
  gtk_widget_ref (frame41);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "frame41", frame41,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame41);
  gtk_container_add (GTK_CONTAINER (frame39), frame41);
  gtk_container_set_border_width (GTK_CONTAINER (frame41), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame41), GTK_SHADOW_NONE);

  table5 = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (table5);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "table5", table5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table5);
  gtk_container_add (GTK_CONTAINER (frame41), table5);

  label22 = gtk_label_new (_("Pixel search:"));
  gtk_widget_ref (label22);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "label22", label22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label22);
  gtk_table_attach (GTK_TABLE (table5), label22, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 3, 3);
  gtk_label_set_justify (GTK_LABEL (label22), GTK_JUSTIFY_LEFT);

  label23 = gtk_label_new (_("Search range:"));
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_table_attach (GTK_TABLE (table5), label23, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 3, 3);
  gtk_label_set_justify (GTK_LABEL (label23), GTK_JUSTIFY_LEFT);

  optionmenu1 = gtk_option_menu_new ();
  gtk_widget_ref (optionmenu1);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "optionmenu1", optionmenu1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (optionmenu1);
  gtk_table_attach (GTK_TABLE (table5), optionmenu1, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 3, 3);
  optionmenu1_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("Half"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu1_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Full"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu1_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu1), optionmenu1_menu);
  gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu1), 1);

  hbox19 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox19);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "hbox19", hbox19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox19);
  gtk_table_attach (GTK_TABLE (table5), hbox19, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 3, 3);

  search_range_low_adj = gtk_adjustment_new (10, 0, 100, 1, 10, 10);
  search_range_low = gtk_spin_button_new (GTK_ADJUSTMENT (search_range_low_adj), 1, 0);
  gtk_widget_ref (search_range_low);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "search_range_low", search_range_low,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_range_low);
  gtk_box_pack_start (GTK_BOX (hbox19), search_range_low, TRUE, TRUE, 3);

  label27 = gtk_label_new (_("-"));
  gtk_widget_ref (label27);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "label27", label27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label27);
  gtk_box_pack_start (GTK_BOX (hbox19), label27, FALSE, TRUE, 3);

  search_range_high_adj = gtk_adjustment_new (10, 0, 100, 1, 10, 10);
  search_range_high = gtk_spin_button_new (GTK_ADJUSTMENT (search_range_high_adj), 1, 0);
  gtk_widget_ref (search_range_high);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "search_range_high", search_range_high,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_range_high);
  gtk_box_pack_start (GTK_BOX (hbox19), search_range_high, TRUE, TRUE, 3);

  hbox17 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox17);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "hbox17", hbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox17);
  gtk_box_pack_start (GTK_BOX (vbox), hbox17, FALSE, TRUE, 3);
  gtk_container_set_border_width (GTK_CONTAINER (hbox17), 3);

  frame42 = gtk_frame_new (_("Algorithms"));
  gtk_widget_ref (frame42);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "frame42", frame42,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame42);
  gtk_box_pack_start (GTK_BOX (hbox17), frame42, TRUE, TRUE, 3);

  frame43 = gtk_frame_new (NULL);
  gtk_widget_ref (frame43);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "frame43", frame43,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame43);
  gtk_container_add (GTK_CONTAINER (frame42), frame43);
  gtk_container_set_border_width (GTK_CONTAINER (frame43), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame43), GTK_SHADOW_NONE);

  table7 = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (table7);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "table7", table7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table7);
  gtk_container_add (GTK_CONTAINER (frame43), table7);

  label24 = gtk_label_new (_("P search algorithm:"));
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_table_attach (GTK_TABLE (table7), label24, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 3, 3);
  gtk_label_set_justify (GTK_LABEL (label24), GTK_JUSTIFY_LEFT);

  label25 = gtk_label_new (_("B search algorithm:"));
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_table_attach (GTK_TABLE (table7), label25, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 3, 3);
  gtk_label_set_justify (GTK_LABEL (label25), GTK_JUSTIFY_LEFT);

  p_search_algorithm = gtk_option_menu_new ();
  gtk_widget_ref (p_search_algorithm);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "p_search_algorithm", p_search_algorithm,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (p_search_algorithm);
  gtk_table_attach (GTK_TABLE (table7), p_search_algorithm, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 3, 3);
  p_search_algorithm_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("Exhaustive"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (p_search_algorithm_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Subsample"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (p_search_algorithm_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Logarithmic"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (p_search_algorithm_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Twolevel"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (p_search_algorithm_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (p_search_algorithm), p_search_algorithm_menu);
  gtk_option_menu_set_history (GTK_OPTION_MENU (p_search_algorithm), 2);

  b_search_algorithm = gtk_option_menu_new ();
  gtk_widget_ref (b_search_algorithm);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "b_search_algorithm", b_search_algorithm,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (b_search_algorithm);
  gtk_table_attach (GTK_TABLE (table7), b_search_algorithm, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 3, 3);
  b_search_algorithm_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("Simple"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (b_search_algorithm_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Cross2"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (b_search_algorithm_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Exhaustive"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (b_search_algorithm_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (b_search_algorithm), b_search_algorithm_menu);

  hbox18 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox18);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "hbox18", hbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox18);
  gtk_box_pack_start (GTK_BOX (vbox), hbox18, TRUE, TRUE, 3);
  gtk_container_set_border_width (GTK_CONTAINER (hbox18), 3);

  label26 = gtk_label_new (_("Reference frame type:"));
  gtk_widget_ref (label26);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "label26", label26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label26);
  gtk_box_pack_start (GTK_BOX (hbox18), label26, FALSE, FALSE, 3);

  reference_frame_type = gtk_option_menu_new ();
  gtk_widget_ref (reference_frame_type);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "reference_frame_type", reference_frame_type,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reference_frame_type);
  gtk_box_pack_start (GTK_BOX (hbox18), reference_frame_type, TRUE, TRUE, 0);
  reference_frame_type_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("Original"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (reference_frame_type_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("Decodec"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (reference_frame_type_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (reference_frame_type), reference_frame_type_menu);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox), hseparator1, TRUE, TRUE, 0);

  hbox20 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox20);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "hbox20", hbox20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox20);
  gtk_box_pack_start (GTK_BOX (vbox), hbox20, TRUE, TRUE, 4);

  ok_config = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (ok_config);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "ok_config", ok_config,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_config);
  gtk_box_pack_start (GTK_BOX (hbox20), ok_config, FALSE, FALSE, 3);

  cancel_config = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (cancel_config);
  gtk_object_set_data_full (GTK_OBJECT (ucbmpeg_config), "cancel_config", cancel_config,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_config);
  gtk_box_pack_start (GTK_BOX (hbox20), cancel_config, FALSE, FALSE, 3);

  gtk_signal_connect (GTK_OBJECT (ucbmpeg_config), "delete_event",
                      GTK_SIGNAL_FUNC (on_ucbmpeg_config_delete_event),
                      v);
  gtk_signal_connect (GTK_OBJECT (ok_config), "clicked",
                      GTK_SIGNAL_FUNC (on_ok_config_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (cancel_config), "clicked",
                      GTK_SIGNAL_FUNC (on_cancel_config_clicked),
                      v);

  return ucbmpeg_config;
}

Config::Config() {
    widget=create_ucbmpeg_config(this);
    gtk_widget_show(widget);
}

Config::~Config() {
    gtk_widget_destroy(widget);
}
