// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef __SUBJECT_H__
#define __SUBJECT_H__

class Observer;

#include <slist.h>
#include <observer.h>

#include <stdio.h>

//#define DEBUG

/* A sender of events */

class Subject {
    slist<Observer*> observers;
    slist<Observer*> del;
protected:
    void clear() {
	observers.clear();
        del.clear();
    }

    void notify(char *event) {
	slist<Observer*>::iterator i;
	Observer *o=NULL;
        flush();
	// Calling left observers
	for (i=observers.begin();i!=observers.end();) {
	    o=*i;
	    i++;
#ifdef DEBUG
	    printf("notify: this = %p (Observer = %p)\n",this,o);
#endif
	    o->notice(event,this);
	}
    }
    void flush() {
	slist<Observer*>::iterator i;
	slist<Observer*>::iterator todel=NULL;
	Observer *o=NULL;
        // Deleting marked observers
	for (i=del.begin();i!=del.end();) {
	    o=*i;
	    i++;
	    todel=search(o,&observers);
	    if (todel!=NULL) {
#ifdef DEBUG
		printf("flush: this = %p (Observer = %p) [%p]\n",this,o,*todel);
#endif
		observers.erase(todel);
	    }
            del.remove(o);
	}
    }
    slist<Observer*>::iterator search(Observer *o, slist<Observer *> *list) {
	slist<Observer*>::iterator i;
	Observer *cur=NULL;
	for (i=list->begin();i!=list->end();) {
	    cur=*i;
	    if (cur==o) {
                return i;
	    }
	    i++;
	}
        return NULL;
    }
public:
    void addObserver(Observer * o) {
#ifdef DEBUG
	printf("addObserver: this = %p (Observer = %p)\n",this,o);
#endif
	observers.insert(observers.end(),o);
    }
    void removeObserver(Observer *o) {
#ifdef DEBUG
	printf("removeObserver: this = %p (Observer = %p)\n",this,o);
#endif
        // Mark this observer to delete
	del.insert(del.begin(),o);
    }
};

#endif
