// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

// Sample filter for ganso

#ifndef __FILTER_H__
#define __FILTER_H__

/**
 * This sample filter makes an stream more and more transparent, it's usefull
 * as the filter for the top image stream of a concurrent image stream, as
 * it allows to make a transition between top stream and next stream of
 * such a concurrent image stream. The top one makes more and more transparent,
 * disappearing, and the next becames more and more visible as the top makes
 * transparent.
 */

#include <image.h>
#include <filterimstream.h>

typedef enum {
    SOLID_TO_TRANSPARENT,
    TRANSPARENT_TO_SOLID
} FilterSense;

class SampleFilter: public FilterImStream {
    int start, end;
    int pos;
    int interpolate();
    FilterSense sense;
public:
    SampleFilter();
    void  processNext         (Image *im);
    void  processRewind       ();
    void  processSeek         (int offset, SeekType type);
    char* getFilterName       ();
    char* getFilterVersion    ();
    char* getFilterCopyright  ();
    char**getFilterAuthors    ();
    char* getFilterDescription();

    void writeSettings(xmlNodePtr xml_node);
    void readSettings(xmlNodePtr xml_node);

    Prototype *clone          ();

    void setStart(int i) { start=i;printf("start:%d\n",i); }
    void setEnd(int i) { end=i;printf("end:%d\n",i); }
    void setSense(FilterSense s) { sense=s; }

    int getStart() { return start; }
    int getEnd() { return end; }
    FilterSense getSense() { return sense; }
};

#endif
