// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

// Sample template for ganso

#include <template.h>
#include <concurrentimstream.h>
#include <seqimstream.h>

static char * icon[] = {
"16 16 2 1",
"       c None",
".      c #000000",
"                ",
"                ",
"  .  .  . . ..  ",
" .  . . ... . . ",
"  . ... . . ..  ",
" .  . . . . .   ",
"                ",
"                ",
"                ",
"                ",
"  .  .  .  .  . ",
"  . .  . . .. . ",
"  . .  . . . .. ",
"  .  .  .  .  . ",
"                ",
"                "};


#define NAME "sample template"
#define VERSION "0.5"
#define COPYRIGHT "Copyright (C) Ruben Lopez Gomez"
#define DESCRIPTION "This is part of the GAnSO sample plugin"

static char *authors[]={
    "Ruben Lopez Gomez",
    NULL
};

/**
 * This sample template only creates a Concurrent Image Stream with two
 * sequential image streams into it.
 */
class SampleTemplate: public Template {
    char ** getIcon();

    // Mandatory Information
    char *getName();
    char *getVersion();
    char *getCopyright();
    char **getAuthors();

    // Optional information
    char *getDescription();

    void build();

    // Stream getting
    ImStream *getStream();

};

char **SampleTemplate::getIcon() {
    return icon;
}

char *SampleTemplate::getName() {
    return NAME;
}

char *SampleTemplate::getVersion() {
    return VERSION;
}

char *SampleTemplate::getCopyright() {
    return COPYRIGHT;
}

char **SampleTemplate::getAuthors() {
    return authors;
}

char *SampleTemplate::getDescription() {
    return DESCRIPTION;
}

void SampleTemplate::build() {
    notify(TEMPLATE_BUILD_COMPLETE);
}

ImStream *SampleTemplate::getStream() {
    ConcurrentImStream *conc=new ConcurrentImStream("sampleConc");
    SeqImStream *seq1=new SeqImStream("sampleSeq1");
    SeqImStream *seq2=new SeqImStream("sampleSeq2");
    conc->append(seq1);
    conc->append(seq2);
    return conc;
}

// Instaling this template automatically when dinamic loaded.
extern "C" {

    class proxy {
    public:
	proxy() {
	    register_video_template(new SampleTemplate());
	}
    };

    proxy templ;
}
