// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "compimstream.h"

void CompImStream::rewindAll () {
    slist<ImStream*>::iterator iter;
    for (iter=streams.begin();iter!=streams.end();iter++)
    {
	ImStream *stream=*iter;
	stream->rewind();
    }
}


void CompImStream::rewind () {
    rewindAll();
}

void CompImStream::seek (int offset, SeekType type) {
    slist<ImStream*>::iterator iter;
    for (iter=streams.begin();iter!=streams.end();iter++)
    {
	ImStream *stream=*iter;
	stream->seek(offset,type);
    }
}

int CompImStream::size () {
    int max=0;
    slist<ImStream*>::iterator iter;
    for (iter=streams.begin();iter!=streams.end();iter++)
    {
	ImStream *stream=*iter;
	int local=stream->size();
	if (local>max) max=local;
    }
    return max;
}

void CompImStream::append(ImStream *stream) {
    stream->addObserver(this);
    streams.insert(streams.end(), stream);
    notify(COMP_APPEND);
}

void CompImStream::remove(ImStream *stream) {
    stream->removeObserver(this);
    streams.remove(stream);
    notify(COMP_REMOVE);
}

void CompImStream::update(ImStream *original, ImStream *newStream) {
    slist<ImStream*>::iterator iter;
    for (iter=streams.begin();iter!=streams.end();iter++)
    {
	ImStream *stream=*iter;
	if (stream==original) {
            *iter=newStream;
	}
    }
    notify(COMP_UPDATE);
}

void CompImStream::notice(char *event, Subject *source) {
    notify(COMP_INTERNAL_CHANGE);
}
