// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/**
 * COMPOSED IMAGE STREAM
 */

#ifndef __COMPIMSTREAM_H__
#define __COMPIMSTREAM_H__

#define COMP_APPEND "CIMSAPPEN"
#define COMP_REMOVE "CIMSREMOV"
#define COMP_UPDATE "CIMSUPDAT"
#define COMP_INTERNAL_CHANGE "CIMSICH"

#include <slist.h>
#include "imstream.h"

class CompImStream: public ImStream, public Observer {
protected:
    slist<ImStream*> streams;
    void rewindAll();
public:
    CompImStream(char *name):ImStream(name) {}
    virtual void nextImage(Image *buffer)=0;
    virtual void rewind    (); // by default, rewind all
    virtual void seek      (int offset, SeekType type); // by default seek all
    virtual int  size      (); // by default max of streams

    virtual void append(ImStream *stream);
    virtual void remove(ImStream *stream);
    virtual void update(ImStream *original, ImStream *newStream);
    slist<ImStream*> getStreams() { return streams; }
    virtual void accept(ImStreamVisitor *visitor)=0;
    void notice(char *event, Subject *source);
};

#endif
