// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <image.h>
#include "creation.h"
#include <stdio.h>

static int nameno=0;
#define namePrefix "noname"
static char* nextName() {
    char name[1024];
    snprintf(name,1023,"%s%04d",namePrefix,nameno++);
    return strdup(name);
}

Creation::Creation() {
    video_stream=NULL;
    video_width=320;
    video_height=240;
    build_progress=0.0;
    name=nextName();
}

Creation::~Creation() {
    if (video_stream) delete video_stream;
    free(name);
}

void Creation::setVideoWidth(int width) {
    video_width=width;
    notify("WIDTH");
}

void Creation::setVideoHeight(int height) {
    video_height=height;
    notify("HEIGHT");
}

void Creation::setCompositionName(char *name) {
    if (this->name)
	free(this->name);
    this->name=strdup(name);
    notify("NAME");
}

void Creation::setVideoStream(ImStream *video_stream) {
    this->video_stream=video_stream;
    notify("VIDEO");
}

bool Creation::check() {
    bool checkpassed=(video_stream!=NULL)
	&& (video_width>0)
	&& (video_height>0)
	&& (name!=NULL);
    if (checkpassed) {
	notify("VALID_DATA");
    }
    return checkpassed;
}

void Creation::compose(VideoCodec *codec) {
    if  (!check()){
	//ERROR
    }else{
	char filename[1024];
	snprintf(filename,1024,"%s.mpg",name);
        video_stream->rewind();
	codec->encode(video_stream,filename,new Image(video_width,video_height));
    }
}

