// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

/**
 * FILE IMAGE STREAM
 */

#ifndef __FILEIMSTREAM_H__
#define __FILEIMSTREAM_H__

#include "videosource.h"
#include "imstream.h"

class FileImStream: public ImStream {
    VideoSource *source;
    int first;  // First frame of the file to be used
    int last;   // Last frame of the file to be used
    int repeat; // Number of times this sequence of the file is repeated
    int position;
    int loop;
public:
    FileImStream(char *name, VideoSource *source);
    void nextImage (Image *buffer);
    void rewind    ();
    void seek      (int offset, SeekType type);
    int  size      ();

    void setFirst(int first);
    int getFirst() { return first; }
    void setLast(int last);
    int getLast() { return last; }
    void setRepeat(int repeat);
    int getRepeat() { return repeat; }
    VideoSource* getSource() { return source; }
    void accept(ImStreamVisitor *visitor);
};

#endif
