// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "filterimstream.h"
#include <imstreamvisitor.h>

FilterImStream::FilterImStream():ImStream(""){}

void FilterImStream::nextImage(Image *buffer) {
    processNext(buffer);
}

void FilterImStream::rewind() {
    filtered->rewind();
    processRewind();
}

void FilterImStream::seek(int offset, SeekType type) {
    filtered->seek(offset,type);
    processSeek(offset,type);
}

int FilterImStream::size() {
    return filtered->size();
}

void FilterImStream::accept(ImStreamVisitor *visitor) {
    visitor->visitFilterImStream(this);
}


static slist<FilterImStream *> filters;

void register_video_filter(FilterImStream *filter) {
    filters.insert(filters.end(),filter);
}

slist<FilterImStream *> get_video_filters() {
    return filters;
}
