// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include "about_dialog.h"
#include "pixmaps/ganso_about.xpm"

static gboolean
on_about_delete_event                  (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        AboutDialog     *d)
{
    delete d;
    return TRUE;
}


static void
on_close_clicked                    (GtkButton       *button,
				     AboutDialog     *v)
{
    delete v;
}


GtkWidget*
create_about (AboutDialog *v)
{
  GtkWidget *about;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *frame1;
  GtkWidget *pixmap1;
  GtkWidget *label1;
  GtkWidget *hbox2;
  GtkWidget *frame2;
  GtkWidget *close;

  about = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (about), "about", about);
  gtk_window_set_title (GTK_WINDOW (about), _("About GANSO"));

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (about), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (about), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 10);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (about), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (about), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (hbox1), frame1, TRUE, FALSE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame1), GTK_SHADOW_OUT);

  pixmap1 = gnome_pixmap_new_from_xpm_d (ganso_about_xpm);
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (about), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_container_add (GTK_CONTAINER (frame1), pixmap1);

  char buffer[1024];
  snprintf(buffer,1024,_("GANSO %s\nGNOME Animation Studio\nCopyright (C) 2000 - 2001 Ruben Lopez"),VERSION);

  label1 = gtk_label_new (buffer);
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (about), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label1), 10, 10);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (about), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  frame2 = gtk_frame_new (NULL);
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (about), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (hbox2), frame2, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame2), GTK_SHADOW_NONE);

  close = gnome_stock_button (GNOME_STOCK_BUTTON_CLOSE);
  gtk_widget_ref (close);
  gtk_object_set_data_full (GTK_OBJECT (about), "close", close,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (close);
  gtk_box_pack_start (GTK_BOX (hbox2), close, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (about), "delete_event",
                      GTK_SIGNAL_FUNC (on_about_delete_event),
                      v);
  gtk_signal_connect (GTK_OBJECT (close), "clicked",
                      GTK_SIGNAL_FUNC (on_close_clicked),
                      v);

  return about;
}


AboutDialog::AboutDialog() {
    this->widget=create_about(this);
    gtk_widget_show(widget);
}

void AboutDialog::action(char *action) {}

void AboutDialog::notice(char *event, Subject *source) {}
