// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef __COMP_VIEW_H__
#define __COMP_VIEW_H__

#include <compimstream.h>
#include <view.h>
#include "new_stream.h"
#include <streameditor.h>

class CompView: public StreamEditor {
protected:
    int selected;

    CompView() {selected=-1;}
    void updateStreams();
    ImStream *getSelectedStream();
    virtual void updateOneStream(ImStream *s)=0;
    virtual void clearVisualList()=0;
    void editCurrent();
    void filterCurrent();
    void buildNewStream();
    virtual void noticeMore(char *event, Subject *source)=0;
public:
    virtual void show()=0;
    void setSelected(int selected);
    virtual void action(char *action)=0;
    void notice(char *event, Subject *source);
    virtual Prototype *clone()=0;
};

#endif
