// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include "concurrent_view.h"

static gboolean
on_concurrent_image_delete_event       (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        ConcurrentView  *v)
{
//    if (v->isCloseable())
    delete v;
    return TRUE;
}


static void
on_about_concurrent_image_stream1_activate
                                        (GtkMenuItem     *menuitem,
					 ConcurrentView  *v)
{
//    v->action("ABOUT");
}


static void
on_about_ganso2_activate               (GtkMenuItem     *menuitem,
                                        ConcurrentView  *v)
{
//    v->action("ABOUTGANSO");
}


static void
on_edit_layer_clicked                  (GtkButton       *button,
                                        ConcurrentView  *v)
{
    v->action("EDIT");
}


static void
on_delete_layer_clicked                (GtkButton       *button,
                                        ConcurrentView  *v)
{
    v->action("DELETE");
}


static void
on_insert_layer_clicked                (GtkButton       *button,
                                        ConcurrentView  *v)
{
    v->action("INSERT");
}


static void
on_up_layer_clicked                    (GtkButton       *button,
                                        ConcurrentView  *v)
{
    v->action("UP");
}


static void
on_down_layer_clicked                  (GtkButton       *button,
                                        ConcurrentView  *v)
{
    v->action("DOWN");
}


static void
on_layers_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        ConcurrentView  *v)
{
    v->setSelected(row);
}

static void
on_filter_layer_clicked                (GtkButton       *button,
                                        ConcurrentView  *v)
{
    v->action("FILTER");
}

static GnomeUIInfo help2_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("About Concurrent Image Stream"),
    NULL,
    on_about_concurrent_image_stream1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType)0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("About GAnSO"),
    NULL,
    on_about_ganso2_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_ABOUT,
    0, (GdkModifierType)0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo menubar3_uiinfo[] =
{
  {
    GNOME_APP_UI_SUBTREE, N_("Help"),
    NULL,
    help2_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType)0, NULL
  },
  GNOMEUIINFO_END
};

static GtkWidget*
create_concurrent_image (ConcurrentView *v)
{
  GtkWidget *concurrent_image;
  GtkWidget *vbox8;
  GtkWidget *menubar3;
  GtkWidget *frame10;
  GtkWidget *hbox6;
  GtkWidget *frame11;
  GtkWidget *frame15;
  GtkWidget *vbox9;
  GtkWidget *toolbar3;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *edit_layer;
  GtkWidget *delete_layer;
  GtkWidget *insert_layer;
  GtkWidget *filter_layer;
  GtkWidget *up_layer;
  GtkWidget *down_layer;
  GtkWidget *scrolledwindow4;
  GtkWidget *layers;
  GtkWidget *label8;
  GtkWidget *frame12;
  GtkWidget *frames_target;
  GtkWidget *statusbar3;

  concurrent_image = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (concurrent_image), "concurrent_image", concurrent_image);
  gtk_window_set_title (GTK_WINDOW (concurrent_image), _("Concurrent Image Streams"));

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox8);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "vbox8", vbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox8);
  gtk_container_add (GTK_CONTAINER (concurrent_image), vbox8);

  menubar3 = gtk_menu_bar_new ();
  gtk_widget_ref (menubar3);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "menubar3", menubar3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar3);
  gtk_box_pack_start (GTK_BOX (vbox8), menubar3, FALSE, FALSE, 0);
  gnome_app_fill_menu (GTK_MENU_SHELL (menubar3), menubar3_uiinfo,
                       NULL, FALSE, 0);

  gtk_widget_ref (menubar3_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "help2",
                            menubar3_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help2_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "about_concurrent_image_stream1",
                            help2_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help2_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "about_ganso2",
                            help2_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  frame10 = gtk_frame_new (NULL);
  gtk_widget_ref (frame10);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "frame10", frame10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame10);
  gtk_box_pack_start (GTK_BOX (vbox8), frame10, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame10), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame10), GTK_SHADOW_NONE);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox6);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "hbox6", hbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox6);
  gtk_container_add (GTK_CONTAINER (frame10), hbox6);

  frame11 = gtk_frame_new (_("Layers"));
  gtk_widget_ref (frame11);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "frame11", frame11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame11);
  gtk_box_pack_start (GTK_BOX (hbox6), frame11, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame11), 5);

  frame15 = gtk_frame_new (NULL);
  gtk_widget_ref (frame15);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "frame15", frame15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame15);
  gtk_container_add (GTK_CONTAINER (frame11), frame15);
  gtk_container_set_border_width (GTK_CONTAINER (frame15), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame15), GTK_SHADOW_NONE);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox9);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "vbox9", vbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox9);
  gtk_container_add (GTK_CONTAINER (frame15), vbox9);

  toolbar3 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar3);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "toolbar3", toolbar3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar3);
  gtk_box_pack_start (GTK_BOX (vbox9), toolbar3, FALSE, FALSE, 0);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar3), GTK_RELIEF_NONE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (concurrent_image, GNOME_STOCK_PIXMAP_PROPERTIES);
  edit_layer = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Edit"),
                                _("Edit selected layer"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (edit_layer);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "edit_layer", edit_layer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit_layer);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (concurrent_image, GNOME_STOCK_PIXMAP_REMOVE);
  delete_layer = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Delete"),
                                _("Delete selected layer"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (delete_layer);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "delete_layer", delete_layer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_layer);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (concurrent_image, GNOME_STOCK_PIXMAP_ADD);
  insert_layer = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Insert"),
                                _("Insert after selected layer"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (insert_layer);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "insert_layer", insert_layer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (insert_layer);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (concurrent_image, GNOME_STOCK_PIXMAP_CONVERT);
  filter_layer = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Filter"),
                                _("Apply a filter to the selected stream"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (filter_layer);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "filter_layer", filter_layer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (filter_layer);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar3));

  tmp_toolbar_icon = gnome_stock_pixmap_widget (concurrent_image, GNOME_STOCK_PIXMAP_TOP);
  up_layer = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Up"),
                                _("Move selected layer up"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (up_layer);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "up_layer", up_layer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (up_layer);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (concurrent_image, GNOME_STOCK_PIXMAP_BOTTOM);
  down_layer = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Down"),
                                _("Move selected layer down"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (down_layer);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "down_layer", down_layer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (down_layer);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (vbox9), scrolledwindow4, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  layers = gtk_clist_new (1);
  gtk_widget_ref (layers);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "layers", layers,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (layers);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), layers);
  gtk_clist_set_column_width (GTK_CLIST (layers), 0, 80);
  gtk_clist_column_titles_show (GTK_CLIST (layers));

  label8 = gtk_label_new (_("Layer"));
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_clist_set_column_widget (GTK_CLIST (layers), 0, label8);

  frame12 = gtk_frame_new (_("Frames"));
  gtk_widget_ref (frame12);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "frame12", frame12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame12);
  gtk_box_pack_start (GTK_BOX (hbox6), frame12, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame12), 5);

  frames_target = gtk_frame_new (NULL);
  gtk_widget_ref (frames_target);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "frames_target", frames_target,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frames_target);
  gtk_container_add (GTK_CONTAINER (frame12), frames_target);
  gtk_container_set_border_width (GTK_CONTAINER (frames_target), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frames_target), GTK_SHADOW_NONE);

  statusbar3 = gtk_statusbar_new ();
  gtk_widget_ref (statusbar3);
  gtk_object_set_data_full (GTK_OBJECT (concurrent_image), "statusbar3", statusbar3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar3);
  gtk_box_pack_start (GTK_BOX (vbox8), statusbar3, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (concurrent_image), "delete_event",
                      GTK_SIGNAL_FUNC (on_concurrent_image_delete_event),
                      v);
  gtk_signal_connect (GTK_OBJECT (edit_layer), "clicked",
                      GTK_SIGNAL_FUNC (on_edit_layer_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (delete_layer), "clicked",
                      GTK_SIGNAL_FUNC (on_delete_layer_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (insert_layer), "clicked",
                      GTK_SIGNAL_FUNC (on_insert_layer_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (filter_layer), "clicked",
                      GTK_SIGNAL_FUNC (on_filter_layer_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (up_layer), "clicked",
                      GTK_SIGNAL_FUNC (on_up_layer_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (down_layer), "clicked",
                      GTK_SIGNAL_FUNC (on_down_layer_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (layers), "select_row",
                      GTK_SIGNAL_FUNC (on_layers_select_row),
                      v);

  return concurrent_image;}


void ConcurrentView::show() {
    widget=create_concurrent_image(this);
    gtk_widget_show(widget);
    updateStreams();
//    closeable=true;
}

void ConcurrentView::clearVisualList() {
    GtkCList *components=GTK_CLIST(lookup("layers"));
    gtk_clist_clear(components);
}

void ConcurrentView::updateOneStream(ImStream *s) {
    GtkCList *components=GTK_CLIST(lookup("layers"));
    char *text[1];
    text[0]=s->getName();
    gtk_clist_append(components,text);
}


void ConcurrentView::noticeMore(char *event, Subject *source) {
}

void ConcurrentView::action(char *action) {
    if (!strcmp(action,"EDIT")) {
	editCurrent();
    }else if (!strcmp(action,"INSERT")){
	buildNewStream();
    }else if (!strcmp(action,"FILTER")){
        filterCurrent();
    }
}

Prototype *ConcurrentView::clone() {
    return new ConcurrentView();
}
