// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef __DEFAULT_TEMPLATE_H__
#define __DEFAULT_TEMPLATE_H__

#include <template.h>

typedef enum {
    DT_FILE,
    DT_SEQUENTIAL,
    DT_CONCURRENT
} DefaultTemplateStream;

class DefaultTemplate: public Template, Observer {
    DefaultTemplateStream type;
    ImStream *stream;
public:
    DefaultTemplate(DefaultTemplateStream stream);
    char ** getIcon();

    // Mandatory Information
    char *getName();
    char *getVersion();
    char *getCopyright();
    char **getAuthors();

    // Optional information
    char *getDescription() { return "Default Template"; }

    void build();

    // Stream getting
    ImStream *getStream();
    void notice(char *event, Subject *source);
};

#endif
