// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include <gnome_driver.h>
#include "support.h"
#include "file_view.h"

static void
on_about_constant_image_stream1_activate
                                        (GtkMenuItem     *menuitem,
                                         FileView    *cv)
{

}


static void
on_about_ganso1_activate               (GtkMenuItem     *menuitem,
                                        FileView    *cv)
{

}


static void
on_name_changed                        (GtkEditable     *editable,
                                        FileView    *cv)
{

}


static void
on_first_changed                    (GtkEditable     *editable,
                                        FileView    *cv)
{
    cv->action("FIRST");
}

static void
on_last_changed                    (GtkEditable     *editable,
                                        FileView    *cv)
{
    cv->action("LAST");
}

static void
on_repeat_changed                    (GtkEditable     *editable,
                                        FileView    *cv)
{
    cv->action("REPEAT");
}


static void
on_image_change_clicked                (GtkButton       *button,
                                        FileView    *cv)
{

}


static void
on_image_edit_clicked                  (GtkButton       *button,
                                        FileView    *cv)
{

}

static gboolean
on_constant_image_delete_event         (GtkWidget       *widget,
                                        GdkEvent        *event,
					FileView    *cv)
{
    delete cv;
    return TRUE;
}

static gboolean
on_const_area_expose_event             (GtkWidget       *widget,
                                        GdkEventExpose  *event,
					FileView    *cv)
{
    cv->action("EXPOSE");
    return FALSE;
}



static GnomeUIInfo help1_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("About File Image Stream"),
    NULL,
    on_about_constant_image_stream1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType)0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("About GAnSO"),
    NULL,
    on_about_ganso1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_ABOUT,
    0, (GdkModifierType)0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo menubar1_uiinfo[] =
{
  {
    GNOME_APP_UI_SUBTREE, N_("Help"),
    NULL,
    help1_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType)0, NULL
  },
  GNOMEUIINFO_END
};

static GtkWidget*
create_constant_image (FileView* v)
{
  GtkWidget *constant_image;
  GtkWidget *vbox6;
  GtkWidget *menubar1;
  GtkWidget *frame1;
  GtkWidget *vbox1;
  GtkWidget *table1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *name;
  GtkObject *first_adj;
  GtkWidget *first;
  GtkWidget *label47;
  GtkWidget *label48;
  GtkObject *last_adj;
  GtkWidget *last;
  GtkObject *repeat_adj;
  GtkWidget *repeat;
  GtkWidget *frame3;
  GtkWidget *frame2;
  GtkWidget *vbox3;
  GtkWidget *scrolledwindow1;
  GtkWidget *viewport1;
  GtkWidget *const_area;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *image_change;
  GtkWidget *image_edit;
  GtkWidget *statusbar1;

  constant_image = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (constant_image), "constant_image", constant_image);
  gtk_window_set_title (GTK_WINDOW (constant_image), _("File Image Stream"));

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_container_add (GTK_CONTAINER (constant_image), vbox6);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_ref (menubar1);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "menubar1", menubar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox6), menubar1, FALSE, FALSE, 0);
  gnome_app_fill_menu (GTK_MENU_SHELL (menubar1), menubar1_uiinfo,
                       NULL, FALSE, 0);

  gtk_widget_ref (menubar1_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "help1",
                            menubar1_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "about_constant_image_stream1",
                            help1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "about_ganso1",
                            help1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox6), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 4);
  gtk_frame_set_shadow_type (GTK_FRAME (frame1), GTK_SHADOW_NONE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (frame1), vbox1);

  table1 = gtk_table_new (4, 3, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox1), table1, FALSE, TRUE, 0);

  label2 = gtk_label_new (_("Name:"));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_table_attach (GTK_TABLE (table1), label2, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label2), 10, 0);

  label3 = gtk_label_new (_("First:"));
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_table_attach (GTK_TABLE (table1), label3, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label3), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label3), 10, 0);

  name = gtk_entry_new ();
  gtk_widget_ref (name);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "name", name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (name);
  gtk_table_attach (GTK_TABLE (table1), name, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  first_adj = gtk_adjustment_new (1, 0, 100, 1, 10, 10);
  first = gtk_spin_button_new (GTK_ADJUSTMENT (first_adj), 1, 0);
  gtk_widget_ref (first);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "first", first,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (first);
  gtk_table_attach (GTK_TABLE (table1), first, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label47 = gtk_label_new (_("Last:"));
  gtk_widget_ref (label47);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "label47", label47,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label47);
  gtk_table_attach (GTK_TABLE (table1), label47, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label47), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label47), 10, 0);

  label48 = gtk_label_new (_("Repeat:"));
  gtk_widget_ref (label48);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "label48", label48,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label48);
  gtk_table_attach (GTK_TABLE (table1), label48, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label48), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label48), 10, 0);

  last_adj = gtk_adjustment_new (1, 0, 100, 1, 10, 10);
  last = gtk_spin_button_new (GTK_ADJUSTMENT (last_adj), 1, 0);
  gtk_widget_ref (last);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "last", last,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (last);
  gtk_table_attach (GTK_TABLE (table1), last, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  repeat_adj = gtk_adjustment_new (1, 0, 100, 1, 10, 10);
  repeat = gtk_spin_button_new (GTK_ADJUSTMENT (repeat_adj), 1, 0);
  gtk_widget_ref (repeat);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "repeat", repeat,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (repeat);
  gtk_table_attach (GTK_TABLE (table1), repeat, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  frame3 = gtk_frame_new (_("Image"));
  gtk_widget_ref (frame3);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "frame3", frame3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox1), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 10);

  frame2 = gtk_frame_new (NULL);
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_container_add (GTK_CONTAINER (frame3), frame2);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame2), GTK_SHADOW_NONE);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (frame2), vbox3);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox3), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "viewport1", viewport1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport1);
  gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport1), GTK_SHADOW_ETCHED_IN);

  const_area = gtk_drawing_area_new ();
  gtk_widget_ref (const_area);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "const_area", const_area,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (const_area);
  gtk_container_add (GTK_CONTAINER (viewport1), const_area);

  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar1);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "toolbar1", toolbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar1);
  gtk_box_pack_start (GTK_BOX (vbox3), toolbar1, FALSE, FALSE, 3);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar1), GTK_RELIEF_NONE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (constant_image, GNOME_STOCK_PIXMAP_OPEN);
  image_change = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Change"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (image_change);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "image_change", image_change,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_change);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (constant_image, GNOME_STOCK_PIXMAP_PROPERTIES);
  image_edit = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Edit"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (image_edit);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "image_edit", image_edit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_edit);

  statusbar1 = gtk_statusbar_new ();
  gtk_widget_ref (statusbar1);
  gtk_object_set_data_full (GTK_OBJECT (constant_image), "statusbar1", statusbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar1);
  gtk_box_pack_start (GTK_BOX (vbox6), statusbar1, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (constant_image), "delete_event",
                      GTK_SIGNAL_FUNC (on_constant_image_delete_event),
                      v);
  gtk_signal_connect (GTK_OBJECT (name), "changed",
                      GTK_SIGNAL_FUNC (on_name_changed),
                      v);
  gtk_signal_connect (GTK_OBJECT (first), "changed",
                      GTK_SIGNAL_FUNC (on_first_changed),
                      v);
  gtk_signal_connect (GTK_OBJECT (last), "changed",
                      GTK_SIGNAL_FUNC (on_last_changed),
                      v);
  gtk_signal_connect (GTK_OBJECT (repeat), "changed",
                      GTK_SIGNAL_FUNC (on_repeat_changed),
                      v);
  gtk_signal_connect (GTK_OBJECT (const_area), "expose_event",
                      GTK_SIGNAL_FUNC (on_const_area_expose_event),
                      v);
  gtk_signal_connect (GTK_OBJECT (image_change), "clicked",
                      GTK_SIGNAL_FUNC (on_image_change_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (image_edit), "clicked",
                      GTK_SIGNAL_FUNC (on_image_edit_clicked),
                      v);

  return constant_image;
}


void FileView::show() {
    FileImStream *domain=(FileImStream*)stream;
    widget=create_constant_image(this);
    gtk_widget_show(widget);
    gc=gdk_gc_new(widget->window);
    regenerate();
    gtk_entry_set_text(GTK_ENTRY(lookup("name")),domain->getName());
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(lookup("first")),(gfloat)domain->getFirst());
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(lookup("last")),(gfloat)domain->getLast());
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(lookup("repeat")),(gfloat)domain->getRepeat());
    gtk_spin_button_get_adjustment(GTK_SPIN_BUTTON(lookup("first")))->lower=0;
    gtk_spin_button_get_adjustment(GTK_SPIN_BUTTON(lookup("last")))->lower=1;
    gtk_spin_button_get_adjustment(GTK_SPIN_BUTTON(lookup("repeat")))->lower=1;
    gtk_spin_button_get_adjustment(GTK_SPIN_BUTTON(lookup("first")))->upper=(gfloat)domain->size();
    gtk_spin_button_get_adjustment(GTK_SPIN_BUTTON(lookup("last")))->upper=(gfloat)domain->size();
    gtk_spin_button_get_adjustment(GTK_SPIN_BUTTON(lookup("repeat")))->upper=100000000;
}

void FileView::notice(char *event, Subject *source) {
    
}

void FileView::action(char *action) {
    FileImStream *domain=(FileImStream*)stream;
//    Image *im=domain->getImage();
    if (!strcmp(action,"EXPOSE")) {
//	GtkWidget *w=lookup("const_area");
//	gdk_draw_pixmap(w->window,gc,pixmap, 0,0,0,0,im->width(),im->height());
    }else if (!strcmp(action,"FIRST")) {
	char *txt=gtk_entry_get_text(GTK_ENTRY(lookup("first")));
	char *end=NULL;
	int value=(int)strtol(txt,&end,10);
	if (end!=txt) {
	    domain->setFirst(value);
	}
    }else if (!strcmp(action,"LAST")) {
	char *txt=gtk_entry_get_text(GTK_ENTRY(lookup("last")));
	char *end=NULL;
	int value=(int)strtol(txt,&end,10);
	if (end!=txt) {
	    domain->setLast(value);
	}
    }else if (!strcmp(action,"REPEAT")) {
	char *txt=gtk_entry_get_text(GTK_ENTRY(lookup("repeat")));
	char *end=NULL;
	int value=(int)strtol(txt,&end,10);
	if (end!=txt) {
	    domain->setRepeat(value);
	}
    }

}

void FileView::regenerate() {
    FileImStream *domain=(FileImStream*)stream;
/*    Image *im=domain->getImage();
    pixmap=gdk_pixmap_new(widget->window, im->width(), im->height(), gdk_visual_get_best_depth());
    draw_image_on_drawable(domain->getImage(),pixmap,gc, gtk_widget_get_colormap(widget));
    */
}

Prototype *FileView::clone() {
    return new FileView();
}
