// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include <image.h>
#include <config.h>
#include <gnome.h>
#include "gnome_driver.h"

static GnomeDriver *_instance=NULL;

GnomeDriver::GnomeDriver() {}


void GnomeDriver::init(int argc, char *argv[]) {
#ifdef ENABLE_NLS
    bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
    textdomain (PACKAGE);
#endif
    gnome_init(PACKAGE, VERSION, argc, argv);
}

void GnomeDriver::main() {
    gtk_main();
}

GnomeDriver *GnomeDriver::instance() {
    if (_instance==NULL) {
	_instance=new GnomeDriver();
    }
    return _instance;
}

/***********************************************************************/
void draw_image_on_drawable(Image *im, GdkDrawable *p, GdkGC *gc, GdkColormap *cmap)
/***********************************************************************/
{
    int width  = im->width();
    int height = im->height();
    Pixel *fb=im->frameBuffer();
    int i,j;
    for (j=0;j<height;j++)
    {
	for (i=0;i<width;i++)
	{
	    GdkColor color;
	    int r,g,b,a,tgt;
	    r=fb->r;
	    g=fb->g;
	    b=fb->b;
	    a=fb->a;
	    if ( ((i/10)+(j/10))%2 == 0) {
		tgt=100;
	    }else{
		tgt=200;
	    }
	    color.red=(a*(r - tgt) + (tgt << 8));
	    color.green=(a*(g - tgt) + (tgt << 8));
	    color.blue=(a*(b - tgt) + (tgt << 8));
	    gdk_color_alloc(cmap,&color);
	    gdk_gc_set_foreground(gc,&color);
	    gdk_draw_point(p,gc,i,j);
	    fb++;
	}
    }
}
