// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef __GNOME_TREE_H__
#define __GNOME_TREE_H__

#include <gnome.h>
#include <imstream.h>
#include <observer.h>

class GnomeTree;

typedef slist<GnomeTree *> TreeList;

class GnomeTree: public Observer {
    GtkWidget *treeitem;
    GtkWidget *tree;
    ImStream *stream;
    TreeList children;
    GtkTree *parent;
    void setPixmap(char **data);
public:
    GnomeTree(ImStream *s, char **pixmap, GtkTree *parent);
    virtual ~GnomeTree();
    
    void notice(char *event, Subject *source);

    // Apply GuiVisitor to the stream to edit it
    void showStream();

    //Show the stream in the preview window
    void showPreview();

    GtkTree *getSubTree();

    TreeList *getChildren() { return &children; }
    ImStream *getStream() { return stream; }

};

#endif
