// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include "about_dialog.h"
#include "new_creation.h"
#include "main_window.h"
#include "select_codec.h"
#include "tree_visitor.h"
#include "question_dialog.h"
#include "preview.h"
#include <gansofile.h>

static gboolean
on_ganso_window_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        MainWindow *v)
{
    gtk_main_quit();
    return TRUE;
}


static void
on_new_file1_activate                  (GtkMenuItem     *menuitem,
                                        MainWindow *v)
{
    v->action("NEW");
}


static void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        MainWindow *v)
{
    v->action("OPEN");
}


static void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        MainWindow *v)
{
    v->action("SAVE");
}


static void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        MainWindow *v)
{
    v->action("SAVE_AS");
}


static void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        MainWindow *v)
{
    gtk_main_quit();
}


static void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        MainWindow *v)
{

}


static void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        MainWindow *v)
{

}


static void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        MainWindow *v)
{

}


static void
on_clear1_activate                     (GtkMenuItem     *menuitem,
                                        MainWindow *v)
{

}


static void
on_properties1_activate                (GtkMenuItem     *menuitem,
                                        MainWindow *v)
{

}


static void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        MainWindow *v)
{

}


static void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        MainWindow *v)
{
    new AboutDialog();
}

static void
on_new_creation_clicked                (GtkButton       *button,
                                        MainWindow *v)
{
    v->action("NEW");
}


static void
on_open_clicked                        (GtkButton       *button,
                                        MainWindow *v)
{
    v->action("OPEN");
}


static void
on_save_clicked                        (GtkButton       *button,
                                        MainWindow *v)
{
    v->action("SAVE");
}


static void
on_build_clicked                       (GtkButton       *button,
                                        MainWindow *v)
{
    v->action("BUILD");
}




static GtkWidget*
create_ganso_window (MainWindow *v)
{
    GnomeUIInfo file1_menu_uiinfo[] =
    {
	GNOMEUIINFO_MENU_NEW_ITEM (N_("_New file"), NULL, on_new_file1_activate, v),
	GNOMEUIINFO_MENU_OPEN_ITEM (on_open1_activate, v),
	GNOMEUIINFO_MENU_SAVE_ITEM (on_save1_activate, v),
	GNOMEUIINFO_MENU_SAVE_AS_ITEM (on_save_as1_activate, v),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_EXIT_ITEM (on_exit1_activate, v),
	GNOMEUIINFO_END
    };

GnomeUIInfo edit1_menu_uiinfo[] =
{
    GNOMEUIINFO_MENU_CUT_ITEM (on_cut1_activate, v),
    GNOMEUIINFO_MENU_COPY_ITEM (on_copy1_activate, v),
    GNOMEUIINFO_MENU_PASTE_ITEM (on_paste1_activate, v),
    GNOMEUIINFO_MENU_CLEAR_ITEM (on_clear1_activate, v),
    GNOMEUIINFO_SEPARATOR,
    GNOMEUIINFO_MENU_PROPERTIES_ITEM (on_properties1_activate, v),
    GNOMEUIINFO_END
};

GnomeUIInfo view1_menu_uiinfo[] =
{
    GNOMEUIINFO_END
};

GnomeUIInfo settings1_menu_uiinfo[] =
{
    GNOMEUIINFO_MENU_PREFERENCES_ITEM (on_preferences1_activate, v),
    GNOMEUIINFO_END
};

GnomeUIInfo help3_menu_uiinfo[] =
{
    GNOMEUIINFO_MENU_ABOUT_ITEM (on_about1_activate, v),
    GNOMEUIINFO_END
};
GnomeUIInfo menubar4_uiinfo[] =
{
    GNOMEUIINFO_MENU_FILE_TREE (file1_menu_uiinfo),
    GNOMEUIINFO_MENU_EDIT_TREE (edit1_menu_uiinfo),
    GNOMEUIINFO_MENU_VIEW_TREE (view1_menu_uiinfo),
    GNOMEUIINFO_MENU_SETTINGS_TREE (settings1_menu_uiinfo),
    GNOMEUIINFO_MENU_HELP_TREE (help3_menu_uiinfo),
    GNOMEUIINFO_END
};

  GtkWidget *ganso_window;
  GtkWidget *dock1;
  GtkWidget *toolbar4;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *new_creation;
  GtkWidget *open;
  GtkWidget *save;
  GtkWidget *build;
  GtkWidget *vpaned1;
  GtkWidget *frame28;
  GtkWidget *frame30;
  GtkWidget *hbox11;
  GtkWidget *vbox17;
  GtkWidget *frame44;
  GtkWidget *label28;
  GtkWidget *scrolledwindow8;
  GtkWidget *viewport3;
  GtkWidget *stream_tree;
  GtkWidget *frame29;
  GtkWidget *label14;
  GtkWidget *appbar1;

  ganso_window = gnome_app_new ("Ganso_gui", _("GAnSO"));
  gtk_object_set_data (GTK_OBJECT (ganso_window), "ganso_window", ganso_window);
  gtk_widget_set_usize (ganso_window, 400, 350);

  dock1 = GNOME_APP (ganso_window)->dock;
  gtk_widget_ref (dock1);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "dock1", dock1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dock1);

  gnome_app_create_menus (GNOME_APP (ganso_window), menubar4_uiinfo);

  gtk_widget_ref (menubar4_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "file1",
                            menubar4_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "new_file1",
                            file1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "open1",
                            file1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "save1",
                            file1_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "save_as1",
                            file1_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "separator1",
                            file1_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[5].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "exit1",
                            file1_menu_uiinfo[5].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar4_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "edit1",
                            menubar4_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "cut1",
                            edit1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "copy1",
                            edit1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit1_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "paste1",
                            edit1_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit1_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "clear1",
                            edit1_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit1_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "separator2",
                            edit1_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit1_menu_uiinfo[5].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "properties1",
                            edit1_menu_uiinfo[5].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar4_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "view1",
                            menubar4_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar4_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "settings1",
                            menubar4_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (settings1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "preferences1",
                            settings1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar4_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "help3",
                            menubar4_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help3_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "about1",
                            help3_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  toolbar4 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar4);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "toolbar4", toolbar4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar4);
  gnome_app_add_toolbar (GNOME_APP (ganso_window), GTK_TOOLBAR (toolbar4), "toolbar4",
                                GNOME_DOCK_ITEM_BEH_EXCLUSIVE,
                                GNOME_DOCK_TOP, 1, 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (toolbar4), 1);
  gtk_toolbar_set_space_size (GTK_TOOLBAR (toolbar4), 16);
  gtk_toolbar_set_space_style (GTK_TOOLBAR (toolbar4), GTK_TOOLBAR_SPACE_LINE);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar4), GTK_RELIEF_NONE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (ganso_window, GNOME_STOCK_PIXMAP_NEW);
  new_creation = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar4),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("New"),
                                _("New composition"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (new_creation);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "new_creation", new_creation,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new_creation);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (ganso_window, GNOME_STOCK_PIXMAP_OPEN);
  open = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar4),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Open"),
                                _("Open composition"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (open);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "open", open,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (open);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (ganso_window, GNOME_STOCK_PIXMAP_SAVE);
  save = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar4),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Save"),
                                _("Save composition"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (save);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "save", save,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (ganso_window, GNOME_STOCK_PIXMAP_EXEC);
  build = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar4),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Build"),
                                _("Build composition"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (build);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "build", build,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (build);

  vpaned1 = gtk_vpaned_new ();
  gtk_widget_ref (vpaned1);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "vpaned1", vpaned1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vpaned1);
  gnome_app_set_contents (GNOME_APP (ganso_window), vpaned1);
  gtk_paned_set_position (GTK_PANED (vpaned1), 120);

  frame28 = gtk_frame_new (_("Video"));
  gtk_widget_ref (frame28);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "frame28", frame28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame28);
  gtk_paned_pack1 (GTK_PANED (vpaned1), frame28, FALSE, TRUE);
  gtk_container_set_border_width (GTK_CONTAINER (frame28), 5);

  frame30 = gtk_frame_new (NULL);
  gtk_widget_ref (frame30);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "frame30", frame30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame30);
  gtk_container_add (GTK_CONTAINER (frame28), frame30);
  gtk_container_set_border_width (GTK_CONTAINER (frame30), 10);
  gtk_frame_set_shadow_type (GTK_FRAME (frame30), GTK_SHADOW_NONE);

  hbox11 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox11);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "hbox11", hbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox11);
  gtk_container_add (GTK_CONTAINER (frame30), hbox11);

  vbox17 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox17);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "vbox17", vbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox17);
  gtk_box_pack_start (GTK_BOX (hbox11), vbox17, TRUE, TRUE, 0);

  frame44 = gtk_frame_new (NULL);
  gtk_widget_ref (frame44);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "frame44", frame44,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame44);
  gtk_box_pack_start (GTK_BOX (vbox17), frame44, FALSE, FALSE, 0);

  label28 = gtk_label_new (_("Stream tree"));
  gtk_widget_ref (label28);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "label28", label28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label28);
  gtk_container_add (GTK_CONTAINER (frame44), label28);

  scrolledwindow8 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow8);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "scrolledwindow8", scrolledwindow8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow8);
  gtk_box_pack_start (GTK_BOX (vbox17), scrolledwindow8, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow8), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  viewport3 = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (viewport3);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "viewport3", viewport3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport3);
  gtk_container_add (GTK_CONTAINER (scrolledwindow8), viewport3);

  stream_tree = gtk_tree_new ();
  gtk_widget_ref (stream_tree);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "stream_tree", stream_tree,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (stream_tree);
  gtk_container_add (GTK_CONTAINER (viewport3), stream_tree);

  frame29 = gtk_frame_new (_("Audio"));
  gtk_widget_ref (frame29);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "frame29", frame29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame29);
  gtk_paned_pack2 (GTK_PANED (vpaned1), frame29, TRUE, TRUE);
  gtk_container_set_border_width (GTK_CONTAINER (frame29), 5);

  label14 = gtk_label_new (_("Not implemented yet."));
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_container_add (GTK_CONTAINER (frame29), label14);

  appbar1 = gnome_appbar_new (TRUE, TRUE, GNOME_PREFERENCES_NEVER);
  gtk_widget_ref (appbar1);
  gtk_object_set_data_full (GTK_OBJECT (ganso_window), "appbar1", appbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (appbar1);
  gnome_app_set_statusbar (GNOME_APP (ganso_window), appbar1);

  gtk_signal_connect (GTK_OBJECT (ganso_window), "delete_event",
                      GTK_SIGNAL_FUNC (on_ganso_window_delete_event),
                      v);
  gnome_app_install_menu_hints (GNOME_APP (ganso_window), menubar4_uiinfo);
  gtk_signal_connect (GTK_OBJECT (new_creation), "clicked",
                      GTK_SIGNAL_FUNC (on_new_creation_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (open), "clicked",
                      GTK_SIGNAL_FUNC (on_open_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (save), "clicked",
                      GTK_SIGNAL_FUNC (on_save_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (build), "clicked",
                      GTK_SIGNAL_FUNC (on_build_clicked),
                      v);

  return ganso_window;
}

MainWindow::MainWindow(Creation *creation) {
    this->widget=create_ganso_window(this);
    gtk_widget_show(widget);
    domain=creation;
    domain->addObserver(this);
    open=NULL;
    saveas=NULL;
    tree=NULL;
}

void MainWindow::action(char *action) {
    if (!strcmp(action,"NEW")) {
	if (domain->getVideoStream() != NULL) {
            QuestionDialog *dlg=new QuestionDialog("REALLY_NEW", _("Do you want to overwrite the current creation?"));
            dlg->addObserver(this);
	}else{
	    new NewCreation(domain);
	}
    }else if (!strcmp(action,"BUILD")) {
	new SelectCodec(domain);
    }else if (!strcmp(action,"SAVE")) {
	char filename[4098];
	strncpy(filename,domain->getCompositionName(),4097);
        strncat(filename,".ganso",4097);
        ganso_write_file(domain->getVideoStream(), filename);
    }else if (!strcmp(action,"OPEN")) {
	if (domain->getVideoStream() != NULL) {
            QuestionDialog *dlg=new QuestionDialog("REALLY_OPEN", _("Do you want to overwrite the current creation?"));
            dlg->addObserver(this);
	}else{
	    open=new SelectFile("Select a GAnSO composition");
	    open->addObserver(this);
	}
    }else if (!strcmp(action,"SAVE_AS")) {
	saveas=new SelectFile("Select a GAnSO composition");
        saveas->addObserver(this);
    }
}

void MainWindow::notice(char *event, Subject *source) {
    if (!strcmp(event,"VIDEO")) {
	if (this->tree!=NULL) {
	    delete(this->tree);
            this->tree=NULL;
	}
	GtkTree *tree=GTK_TREE(lookup("stream_tree"));
	TreeVisitor tv(tree);
	domain->getVideoStream()->accept(&tv);
        this->tree=tv.getTree();
	Preview::instance()->setSize(domain->getVideoWidth(),domain->getVideoHeight());
	Preview::instance()->setStream(domain->getVideoStream());
    }else if (!strcmp(event,"WIDTH") || !strcmp(event,"HEIGHT")) {
	Preview::instance()->setSize(domain->getVideoWidth(),domain->getVideoHeight());
    }else if (strstr(event,"FILE_SELECTED")==event) {
	char s[1024];
	sscanf(event,"FILE_SELECTED: %s",s);

	if (source==open) {
	    ImStream *stream=ganso_read_file(s);
	    if (stream!=NULL) {
		domain->setVideoStream(stream);
	    }else{
		//error
	    }
            open=NULL;
	}else if (source==saveas) {
	    ganso_write_file(domain->getVideoStream(), s);
            saveas=NULL;
	}
    }else if (!strcmp(event,"REALLY_NEW")) {
	new NewCreation(domain);
    }else if (!strcmp(event,"REALLY_OPEN")) {
	open=new SelectFile(_("Select a GAnSO composition"));
	open->addObserver(this);
    }
}
