// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include <concurrentimstream.h>
#include "concurrent_view.h"
#include "new_creation.h"
#include <gui_visitor.h>

static gboolean
on_new_creation_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        NewCreation *v)
{

    return TRUE;
}

static void
on_creation_name_changed               (GtkEditable     *editable,
                                        NewCreation *v)
{
    v->action("NAME");
}

static void
on_audio_toggled                       (GtkToggleButton *togglebutton,
                                        NewCreation *v)
{

}


static void
on_video_toggled                       (GtkToggleButton *togglebutton,
                                        NewCreation *v)
{
    v->action("VIDEO");
}


static void
on_width_changed                       (GtkEditable     *editable,
                                        NewCreation *v)
{
    v->action("WIDTH");
}


static void
on_height_changed                      (GtkEditable     *editable,
                                        NewCreation *v)
{
    v->action("HEIGHT");
}


static void
on_ok_clicked                          (GtkButton       *button,
                                        NewCreation *v)
{
    if (v->check()) {
        v->launchWindow();
	delete v;
    }else{
	//ERROR
    }
}


static void
on_cancel_clicked                      (GtkButton       *button,
                                        NewCreation *v)
{
    delete v;
}

static GtkWidget*
create_new_creation (NewCreation *v)
{
  GtkWidget *new_creation;
  GtkWidget *frame19;
  GtkWidget *vbox12;
  GtkWidget *frame26;
  GtkWidget *frame27;
  GtkWidget *hbox10;
  GtkWidget *label12;
  GtkWidget *creation_name;
  GtkWidget *frame20;
  GtkWidget *frame22;
  GtkWidget *vbox13;
  GtkWidget *audio;
  GtkWidget *frame21;
  GtkWidget *frame23;
  GtkWidget *vbox14;
  GtkWidget *video;
  GtkWidget *frame24;
  GtkWidget *frame25;
  GtkWidget *table2;
  GtkWidget *label10;
  GtkWidget *label11;
  GtkWidget *width;
  GtkWidget *height;
  GtkWidget *hbox9;
  GtkWidget *ok;
  GtkWidget *cancel;

  new_creation = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (new_creation), "new_creation", new_creation);
  gtk_window_set_title (GTK_WINDOW (new_creation), _("New Creation"));

  frame19 = gtk_frame_new (NULL);
  gtk_widget_ref (frame19);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "frame19", frame19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame19);
  gtk_container_add (GTK_CONTAINER (new_creation), frame19);
  gtk_container_set_border_width (GTK_CONTAINER (frame19), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame19), GTK_SHADOW_NONE);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox12);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "vbox12", vbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox12);
  gtk_container_add (GTK_CONTAINER (frame19), vbox12);

  frame26 = gtk_frame_new (_("Creation"));
  gtk_widget_ref (frame26);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "frame26", frame26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame26);
  gtk_box_pack_start (GTK_BOX (vbox12), frame26, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame26), 5);

  frame27 = gtk_frame_new (NULL);
  gtk_widget_ref (frame27);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "frame27", frame27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame27);
  gtk_container_add (GTK_CONTAINER (frame26), frame27);
  gtk_container_set_border_width (GTK_CONTAINER (frame27), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame27), GTK_SHADOW_NONE);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox10);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "hbox10", hbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox10);
  gtk_container_add (GTK_CONTAINER (frame27), hbox10);

  label12 = gtk_label_new (_("Creation Name:"));
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_box_pack_start (GTK_BOX (hbox10), label12, FALSE, FALSE, 5);

  creation_name = gtk_entry_new ();
  gtk_widget_ref (creation_name);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "creation_name", creation_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (creation_name);
  gtk_box_pack_start (GTK_BOX (hbox10), creation_name, TRUE, TRUE, 5);

  frame20 = gtk_frame_new (_("Audio"));
  gtk_widget_ref (frame20);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "frame20", frame20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame20);
  gtk_box_pack_start (GTK_BOX (vbox12), frame20, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame20), 5);

  frame22 = gtk_frame_new (NULL);
  gtk_widget_ref (frame22);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "frame22", frame22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame22);
  gtk_container_add (GTK_CONTAINER (frame20), frame22);
  gtk_container_set_border_width (GTK_CONTAINER (frame22), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame22), GTK_SHADOW_NONE);

  vbox13 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox13);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "vbox13", vbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox13);
  gtk_container_add (GTK_CONTAINER (frame22), vbox13);

  audio = gtk_check_button_new_with_label (_("Enable Audio Stream"));
  gtk_widget_ref (audio);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "audio", audio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (audio);
  gtk_box_pack_start (GTK_BOX (vbox13), audio, FALSE, FALSE, 0);

  frame21 = gtk_frame_new (_("Video"));
  gtk_widget_ref (frame21);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "frame21", frame21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame21);
  gtk_box_pack_start (GTK_BOX (vbox12), frame21, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame21), 5);

  frame23 = gtk_frame_new (NULL);
  gtk_widget_ref (frame23);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "frame23", frame23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame23);
  gtk_container_add (GTK_CONTAINER (frame21), frame23);
  gtk_container_set_border_width (GTK_CONTAINER (frame23), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame23), GTK_SHADOW_NONE);

  vbox14 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox14);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "vbox14", vbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox14);
  gtk_container_add (GTK_CONTAINER (frame23), vbox14);

  video = gtk_check_button_new_with_label (_("Enable Video Stream"));
  gtk_widget_ref (video);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "video", video,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (video);
  gtk_box_pack_start (GTK_BOX (vbox14), video, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (video), TRUE);

  frame24 = gtk_frame_new (_("Frame Size"));
  gtk_widget_ref (frame24);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "frame24", frame24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame24);
  gtk_box_pack_start (GTK_BOX (vbox14), frame24, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame24), 5);

  frame25 = gtk_frame_new (NULL);
  gtk_widget_ref (frame25);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "frame25", frame25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame25);
  gtk_container_add (GTK_CONTAINER (frame24), frame25);
  gtk_container_set_border_width (GTK_CONTAINER (frame25), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame25), GTK_SHADOW_NONE);

  table2 = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (frame25), table2);

  label10 = gtk_label_new (_("Width:"));
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_table_attach (GTK_TABLE (table2), label10, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 5, 3);

  label11 = gtk_label_new (_("Height:"));
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_table_attach (GTK_TABLE (table2), label11, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 5, 3);

  width = gtk_entry_new ();
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table2), width, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 5, 0);

  height = gtk_entry_new ();
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table2), height, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 5, 0);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox9);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "hbox9", hbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox9);
  gtk_box_pack_start (GTK_BOX (vbox12), hbox9, FALSE, TRUE, 0);

  ok = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (ok);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "ok", ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok);
  gtk_box_pack_start (GTK_BOX (hbox9), ok, FALSE, FALSE, 5);

  cancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (cancel);
  gtk_object_set_data_full (GTK_OBJECT (new_creation), "cancel", cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel);
  gtk_box_pack_start (GTK_BOX (hbox9), cancel, FALSE, FALSE, 5);

  gtk_signal_connect (GTK_OBJECT (new_creation), "delete_event",
                      GTK_SIGNAL_FUNC (on_new_creation_delete_event),
                      v);
  gtk_signal_connect (GTK_OBJECT (creation_name), "changed",
                      GTK_SIGNAL_FUNC (on_creation_name_changed),
                      v);
  gtk_signal_connect (GTK_OBJECT (audio), "toggled",
                      GTK_SIGNAL_FUNC (on_audio_toggled),
                      v);
  gtk_signal_connect (GTK_OBJECT (video), "toggled",
                      GTK_SIGNAL_FUNC (on_video_toggled),
                      v);
  gtk_signal_connect (GTK_OBJECT (width), "changed",
                      GTK_SIGNAL_FUNC (on_width_changed),
                      v);
  gtk_signal_connect (GTK_OBJECT (height), "changed",
                      GTK_SIGNAL_FUNC (on_height_changed),
                      v);
  gtk_signal_connect (GTK_OBJECT (ok), "clicked",
                      GTK_SIGNAL_FUNC (on_ok_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_cancel_clicked),
                      v);

  return new_creation;
}

NewCreation::NewCreation(Creation *c) {
    char tmp[1024];
    this->widget=create_new_creation(this);
    gtk_widget_show(widget);
    creation=c;
    char *componame=c->getCompositionName();
    gtk_entry_set_text(GTK_ENTRY(lookup("creation_name")), componame);
    free(componame);
    snprintf(tmp,1023,"%d",c->getVideoWidth());
    gtk_entry_set_text(GTK_ENTRY(lookup("width")), tmp);
    snprintf(tmp,1023,"%d",c->getVideoHeight());
    gtk_entry_set_text(GTK_ENTRY(lookup("height")), tmp);
}

void NewCreation::action(char *action) {
    if (!strcmp(action,"VIDEO")) {
	GtkToggleButton *toggle=GTK_TOGGLE_BUTTON(lookup("video"));
	if (toggle->active) {
	    gtk_widget_set_sensitive(lookup("width"),TRUE);
	    gtk_widget_set_sensitive(lookup("height"),TRUE);
	}else{
	    gtk_widget_set_sensitive(lookup("width"),FALSE);
	    gtk_widget_set_sensitive(lookup("height"),FALSE);
	    
	}
    }else if (!strcmp(action,"WIDTH")) {
        int width=atoi(gtk_entry_get_text(GTK_ENTRY(lookup("width"))));
	creation->setVideoWidth(width);
    }else if (!strcmp(action,"HEIGHT")) {
        int height=atoi(gtk_entry_get_text(GTK_ENTRY(lookup("height"))));
	creation->setVideoHeight(height);
    }else if (!strcmp(action,"NAME")) {
        char *name=gtk_entry_get_text(GTK_ENTRY(lookup("creation_name")));
        ConcurrentImStream *cis=new ConcurrentImStream(name);
	creation->setCompositionName(name);
        creation->setVideoStream(cis);
    }
}

void NewCreation::launchWindow() {
    GuiVisitor visitor;
    creation->getVideoStream()->accept(&visitor);
}
