// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include "new_stream.h"
#include <fileimstream.h>
#include <seqimstream.h>
#include <concurrentimstream.h>
#include <imageproxy.h>
#include "select_image.h"

gboolean
on_new_stream_delete_event             (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        NewStream *v)
{
  return TRUE;
}


void
on_stream_name_changed                 (GtkEditable     *editable,
                                        NewStream *v)
{
    v->action("NAME");
}


void
on_new_stream_ok_clicked               (GtkButton       *button,
                                        NewStream *v)
{
    v->action("OK");
}


void
on_new_stream_cancel_clicked           (GtkButton       *button,
                                        NewStream *v)
{
    delete v;
}


GtkWidget*
create_new_stream (NewStream *v)
{
  GtkWidget *new_stream;
  GtkWidget *frame16;
  GtkWidget *vbox10;
  GtkWidget *hbox7;
  GtkWidget *label9;
  GtkWidget *stream_name;
  GtkWidget *frame17;
  GtkWidget *frame18;
  GtkWidget *vbox11;
  GSList *StreamType_group = NULL;
  GtkWidget *constant;
  GtkWidget *sequential;
  GtkWidget *concurrent;
  GtkWidget *hbox8;
  GtkWidget *new_stream_ok;
  GtkWidget *new_stream_cancel;

  new_stream = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (new_stream), "new_stream", new_stream);
  gtk_window_set_title (GTK_WINDOW (new_stream), _("Add a new Image Stream"));

  frame16 = gtk_frame_new (NULL);
  gtk_widget_ref (frame16);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "frame16", frame16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame16);
  gtk_container_add (GTK_CONTAINER (new_stream), frame16);
  gtk_container_set_border_width (GTK_CONTAINER (frame16), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame16), GTK_SHADOW_NONE);

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox10);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "vbox10", vbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox10);
  gtk_container_add (GTK_CONTAINER (frame16), vbox10);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox7);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "hbox7", hbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox7);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox7, FALSE, TRUE, 10);

  label9 = gtk_label_new (_("Name of the stream:"));
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_box_pack_start (GTK_BOX (hbox7), label9, FALSE, FALSE, 10);

  stream_name = gtk_entry_new ();
  gtk_widget_ref (stream_name);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "stream_name", stream_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (stream_name);
  gtk_box_pack_start (GTK_BOX (hbox7), stream_name, TRUE, TRUE, 10);

  frame17 = gtk_frame_new (_("Stream Type"));
  gtk_widget_ref (frame17);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "frame17", frame17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame17);
  gtk_box_pack_start (GTK_BOX (vbox10), frame17, TRUE, TRUE, 0);

  frame18 = gtk_frame_new (NULL);
  gtk_widget_ref (frame18);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "frame18", frame18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame18);
  gtk_container_add (GTK_CONTAINER (frame17), frame18);
  gtk_container_set_border_width (GTK_CONTAINER (frame18), 10);
  gtk_frame_set_shadow_type (GTK_FRAME (frame18), GTK_SHADOW_NONE);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox11);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "vbox11", vbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox11);
  gtk_container_add (GTK_CONTAINER (frame18), vbox11);

  constant = gtk_radio_button_new_with_label (StreamType_group, _("Constant Image Stream"));
  StreamType_group = gtk_radio_button_group (GTK_RADIO_BUTTON (constant));
  gtk_widget_ref (constant);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "constant", constant,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (constant);
  gtk_box_pack_start (GTK_BOX (vbox11), constant, FALSE, FALSE, 0);

  sequential = gtk_radio_button_new_with_label (StreamType_group, _("Sequential Image Streams"));
  StreamType_group = gtk_radio_button_group (GTK_RADIO_BUTTON (sequential));
  gtk_widget_ref (sequential);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "sequential", sequential,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sequential);
  gtk_box_pack_start (GTK_BOX (vbox11), sequential, FALSE, FALSE, 0);

  concurrent = gtk_radio_button_new_with_label (StreamType_group, _("Concurrent Image Streams"));
  StreamType_group = gtk_radio_button_group (GTK_RADIO_BUTTON (concurrent));
  gtk_widget_ref (concurrent);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "concurrent", concurrent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (concurrent);
  gtk_box_pack_start (GTK_BOX (vbox11), concurrent, FALSE, FALSE, 0);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox8);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "hbox8", hbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox8, FALSE, TRUE, 5);

  new_stream_ok = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (new_stream_ok);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "new_stream_ok", new_stream_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new_stream_ok);
  gtk_box_pack_start (GTK_BOX (hbox8), new_stream_ok, FALSE, FALSE, 10);

  new_stream_cancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (new_stream_cancel);
  gtk_object_set_data_full (GTK_OBJECT (new_stream), "new_stream_cancel", new_stream_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new_stream_cancel);
  gtk_box_pack_start (GTK_BOX (hbox8), new_stream_cancel, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (new_stream), "delete_event",
                      GTK_SIGNAL_FUNC (on_new_stream_delete_event),
                      v);
  gtk_signal_connect (GTK_OBJECT (stream_name), "changed",
                      GTK_SIGNAL_FUNC (on_stream_name_changed),
                      v);
  gtk_signal_connect (GTK_OBJECT (new_stream_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_new_stream_ok_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (new_stream_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_new_stream_cancel_clicked),
                      v);

  return new_stream;
}

NewStream::NewStream() {
    this->widget=create_new_stream(this);
    gtk_widget_show(widget);
    name=NULL;
    stream=NULL;
    gtk_entry_set_text(GTK_ENTRY(lookup("stream_name")),"noname");
}

void NewStream::buildStream() {
    GtkToggleButton *constant=GTK_TOGGLE_BUTTON(lookup("constant"));
    GtkToggleButton *sequential=GTK_TOGGLE_BUTTON(lookup("sequential"));
//    GtkToggleButton *concurrent=GTK_TOGGLE_BUTTON(lookup("concurrent"));
    if (constant->active) {
	SelectImage *selector=new SelectImage();
	selector->addObserver(this);
    }else if (sequential->active) {
	stream=new SeqImStream(name);
	notify("BUILD_COMPLETE");
	delete(this);
    }else{
	stream=new ConcurrentImStream(name);
	notify("BUILD_COMPLETE");
	delete(this);
    }
}

void NewStream::action(char *action) {
    if (!strcmp(action,"NAME")) {
        name=gtk_entry_get_text(GTK_ENTRY(lookup("stream_name")));
    }else if (!strcmp(action,"OK")) {
	if (name) {
	    buildStream();
	}else{
            //ERROR
	}
    }
}

void NewStream::notice(char *event, Subject *source) {
    if (strstr(event,"IMAGE_SELECTED")==event) {
	char s[1024];
	sscanf(event,"IMAGE_SELECTED: %s",s);
	stream=new ConstImStream(name,1,new ImageProxy(s));
	notify("BUILD_COMPLETE");
	delete(this);
    }
}
