// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef __PATTERN_TEMPLATE_H__
#define __PATTERN_TEMPLATE_H__

#include <template.h>
#include <view.h>

typedef enum {
    PT_ASCENDING,
    PT_DESCENDING
} PatternTemplateSorting;

class PatternTemplate: public Template, View {
    ImStream *stream;
    bool hidden;
    char *directory;
    char *prefix;
    char *suffix;
    int first,last;
    bool fill_zeros;
    int digits;
    PatternTemplateSorting type;
    void checkDirectory();
    void checkPattern();
public:
    PatternTemplate();
    char ** getIcon();

    // Mandatory Information
    char *getName();
    char *getVersion();
    char *getCopyright();
    char **getAuthors();

    // Optional information
    char *getDescription() { return "Pattern Template"; }

    // Stream building
    void build();

    // Stream getting
    ImStream *getStream();


    void action(char *action);
    void hide();
    void setDirectory(char *dir);
    void setPrefix(char *prefix);
    void setSuffix(char *suffix);
    void setFirst(int first);
    void setLast(int last);
    void setFill(bool fill);
    void setDigits(int digits);
    void setSorting(PatternTemplateSorting type);
};

#endif
