// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include "progress_metter.h"

static gboolean
on_progressmetter_delete_event           (GtkWidget       *widget,
					  GdkEvent        *event,
					  ProgressMetter     *v)
{
    return TRUE;
}

GtkWidget*
create_progressmetter (ProgressMetter *v)
{
  GtkWidget *progressmetter;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *progressbar1;

  progressmetter = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (progressmetter), "progressmetter", progressmetter);
  gtk_window_set_title (GTK_WINDOW (progressmetter), _("Video Building Progress"));

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (progressmetter), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (progressmetter), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 10);

  label1 = gtk_label_new (_("Video Building Progress ..."));
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (progressmetter), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label1), 10, 10);

  progressbar1 = gtk_progress_bar_new ();
  gtk_widget_ref (progressbar1);
  gtk_object_set_data_full (GTK_OBJECT (progressmetter), "progressbar1", progressbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (progressbar1);
  gtk_box_pack_start (GTK_BOX (vbox1), progressbar1, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (progressmetter), "delete_event",
                      GTK_SIGNAL_FUNC (on_progressmetter_delete_event),
                      v);

  return progressmetter;
}


ProgressMetter::ProgressMetter(VideoCodec *codec) {
    widget=create_progressmetter(this);
    gtk_widget_show(widget);
    gtk_grab_add(widget);
    this->codec=codec;
    codec->addObserver(this);
}

void ProgressMetter::action(char *action) {

}

void ProgressMetter::notice(char *event, Subject *source) {
    if (!strcmp(event,"PROGRESS")) {
	GtkProgressBar *bar=GTK_PROGRESS_BAR(lookup("progressbar1"));
	double progress=codec->getProgress();
	if (progress<1.0) {
	    gtk_progress_bar_update(bar,progress);
	}else{
	    codec->removeObserver(this);
            delete(this);
	}

    }
}

