// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include "support.h"
#include "stdarg.h"
#include "question_dialog.h"
#include "pixmaps/question.xpm"

static gboolean
on_question_delete_event           (GtkWidget       *widget,
				    GdkEvent        *event,
				    QuestionDialog     *v)
{
    delete v;
    return TRUE;
}

static void
on_button4_clicked                    (GtkButton       *button,
				       QuestionDialog     *v)
{
    v->action("OK");
}

static void
on_button6_clicked                    (GtkButton       *button,
				       QuestionDialog     *v)
{
    delete v;
}


GtkWidget*
create_question (QuestionDialog *v)
{
  GtkWidget *question;
  GtkWidget *pixmap1;
  GtkWidget *dialog_vbox2;
  GtkWidget *hbox34;
  GtkWidget *thequestion;
  GtkWidget *dialog_action_area2;
  GtkWidget *button4;
  GtkWidget *button6;

  question = gnome_dialog_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (question), "question", question);
  GTK_WINDOW (question)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (question), GTK_WIN_POS_MOUSE);
  gtk_window_set_policy (GTK_WINDOW (question), FALSE, FALSE, FALSE);

  dialog_vbox2 = GNOME_DIALOG (question)->vbox;
  gtk_object_set_data (GTK_OBJECT (question), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);



  hbox34 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox34);
  gtk_object_set_data_full (GTK_OBJECT (question), "hbox34", hbox34,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox34);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), hbox34, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox34), 10);

  pixmap1 = gnome_pixmap_new_from_xpm_d (question_xpm);
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (question), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox34), pixmap1, FALSE, TRUE, 0);

  thequestion = gtk_label_new (_("Question!"));
  gtk_widget_ref (thequestion);
  gtk_object_set_data_full (GTK_OBJECT (question), "question", thequestion,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (thequestion);
  gtk_box_pack_start (GTK_BOX (hbox34), thequestion, FALSE, FALSE, 0);
                                     



  dialog_action_area2 = GNOME_DIALOG (question)->action_area;
  gtk_object_set_data (GTK_OBJECT (question), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area2), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area2), 8);

  gnome_dialog_append_button (GNOME_DIALOG (question), GNOME_STOCK_BUTTON_OK);
  button4 = GTK_WIDGET (g_list_last (GNOME_DIALOG (question)->buttons)->data);
  gtk_widget_ref (button4);
  gtk_object_set_data_full (GTK_OBJECT (question), "button4", button4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button4);
  GTK_WIDGET_SET_FLAGS (button4, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (question), GNOME_STOCK_BUTTON_CANCEL);
  button6 = GTK_WIDGET (g_list_last (GNOME_DIALOG (question)->buttons)->data);
  gtk_widget_ref (button6);
  gtk_object_set_data_full (GTK_OBJECT (question), "button6", button6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button6);
  GTK_WIDGET_SET_FLAGS (button6, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (question), "delete_event",
                      GTK_SIGNAL_FUNC (on_question_delete_event),
                      v);
  gtk_signal_connect (GTK_OBJECT (button4), "clicked",
                      GTK_SIGNAL_FUNC (on_button4_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (button6), "clicked",
                      GTK_SIGNAL_FUNC (on_button6_clicked),
                      v);

  return question;
}

QuestionDialog::QuestionDialog(char *expected_msg, char *fmt, ...) {
    char buffer[4096];
    va_list ap;
                        
    va_start(ap,fmt);
    vsnprintf(buffer, 4095, fmt, ap);
    va_end(ap);

    widget=create_question(this);
    gtk_label_set_text(GTK_LABEL(lookup("question")), buffer);
    gtk_widget_show(widget);
    gtk_grab_add(widget);
    this->expected_message=expected_msg;
}

void QuestionDialog::action(char *action) {
    if (!strcmp(action,"OK")) {
	notify(expected_message);
        delete(this);
    }
}
