// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include "select_file.h"

static gboolean
on_fileselection1_delete_event         (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        SelectFile *v)
{
    delete v;
    return TRUE;
}


static void
on_ok_button1_clicked                  (GtkButton       *button,
                                        SelectFile *v)
{
    v->action("OK");
}


static void
on_cancel_button1_clicked              (GtkButton       *button,
                                        SelectFile *v)
{
    delete v;
}


static GtkWidget*
create_select_file (SelectFile *v, char *title)
{
  GtkWidget *select_image;
  GtkWidget *ok_button1;
  GtkWidget *cancel_button1;

  select_image = gtk_file_selection_new (title);
  gtk_object_set_data (GTK_OBJECT (select_image), "select_image", select_image);
  gtk_container_set_border_width (GTK_CONTAINER (select_image), 10);

  ok_button1 = GTK_FILE_SELECTION (select_image)->ok_button;
  gtk_object_set_data (GTK_OBJECT (select_image), "ok_button1", ok_button1);
  gtk_widget_show (ok_button1);
  GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);

  cancel_button1 = GTK_FILE_SELECTION (select_image)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (select_image), "cancel_button1", cancel_button1);
  gtk_widget_show (cancel_button1);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (select_image), "delete_event",
                      GTK_SIGNAL_FUNC (on_fileselection1_delete_event),
                      v);
  gtk_signal_connect (GTK_OBJECT (ok_button1), "clicked",
                      GTK_SIGNAL_FUNC (on_ok_button1_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (cancel_button1), "clicked",
                      GTK_SIGNAL_FUNC (on_cancel_button1_clicked),
                      v);

  return select_image;
}

SelectFile::SelectFile(char *title) {
    this->widget=create_select_file(this,title);
    gtk_widget_show(widget);
    gtk_grab_add(widget);
}

void SelectFile::action(char *action) {
    if (!strcmp(action,"OK")) {

	char s[1024];
	snprintf(s,1024,"FILE_SELECTED: %s",gtk_file_selection_get_filename(GTK_FILE_SELECTION(widget)));
	gtk_grab_remove(widget);
	notify(s);
	delete(this);
    }
}
