// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include <gdk_imlib.h>
#include <select_template.h>
#include <stdio.h>

static void
on_templates_select_icon               (GnomeIconList   *gnomeiconlist,
                                        gint             arg1,
                                        GdkEvent        *event,
                                        SelectTemplate  *st)
{
    if (event->type == GDK_2BUTTON_PRESS) {
	st->setTemplate(arg1);
        st->action("OK");
    }else{
        st->setTemplate(arg1);
    }

}


static void
on_templates_unselect_icon             (GnomeIconList   *gnomeiconlist,
                                        gint             arg1,
                                        GdkEvent        *event,
                                        SelectTemplate  *st)
{
    st->setTemplate(-1);
}


static void
on_about_template_clicked              (GtkButton       *button,
                                        SelectTemplate  *st)
{
    st->action("ABOUT");
}


static void
on_ok_Template_clicked                 (GtkButton       *button,
                                        SelectTemplate  *st)
{
    st->action("OK");
}


static void
on_cancel_template_clicked             (GtkButton       *button,
                                        SelectTemplate  *st)
{
    st->hide();
}


static gboolean
on_template_selector_delete_event      (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        SelectTemplate  *st)
{
    st->hide();
    return TRUE;
}

static GtkWidget*
create_template_selector (SelectTemplate *v)
{
  GtkWidget *template_selector;
  GtkWidget *vbox20;
  GtkWidget *frame48;
  GtkWidget *vbox21;
  GtkWidget *frame52;
  GtkWidget *scrolledwindow10;
  GtkWidget *templates;
  GtkWidget *hbox24;
  GtkWidget *about_template;
  GtkWidget *frame51;
  GtkWidget *hbox23;
  GtkWidget *frame50;
  GtkWidget *ok_Template;
  GtkWidget *cancel_template;

  template_selector = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (template_selector), "template_selector", template_selector);
  gtk_widget_set_usize (template_selector, 400, 300);
  gtk_container_set_border_width (GTK_CONTAINER (template_selector), 10);
  gtk_window_set_title (GTK_WINDOW (template_selector), _("Select a template"));

  vbox20 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox20);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "vbox20", vbox20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox20);
  gtk_container_add (GTK_CONTAINER (template_selector), vbox20);

  frame48 = gtk_frame_new (_("Templates"));
  gtk_widget_ref (frame48);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "frame48", frame48,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame48);
  gtk_box_pack_start (GTK_BOX (vbox20), frame48, TRUE, TRUE, 5);

  vbox21 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox21);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "vbox21", vbox21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox21);
  gtk_container_add (GTK_CONTAINER (frame48), vbox21);
  gtk_container_set_border_width (GTK_CONTAINER (vbox21), 5);

  frame52 = gtk_frame_new (NULL);
  gtk_widget_ref (frame52);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "frame52", frame52,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame52);
  gtk_box_pack_start (GTK_BOX (vbox21), frame52, TRUE, TRUE, 3);
  gtk_frame_set_shadow_type (GTK_FRAME (frame52), GTK_SHADOW_IN);

  scrolledwindow10 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow10);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "scrolledwindow10", scrolledwindow10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow10);
  gtk_container_add (GTK_CONTAINER (frame52), scrolledwindow10);

  templates = gnome_icon_list_new_flags (78, NULL, 0);
  gtk_widget_ref (templates);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "templates", templates,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (templates);
  gtk_container_add (GTK_CONTAINER (scrolledwindow10), templates);

  hbox24 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox24);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "hbox24", hbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox24);
  gtk_box_pack_start (GTK_BOX (vbox21), hbox24, FALSE, FALSE, 3);

  about_template = gtk_button_new_with_label (_("About"));
  gtk_widget_ref (about_template);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "about_template", about_template,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about_template);
  gtk_box_pack_start (GTK_BOX (hbox24), about_template, FALSE, FALSE, 0);

  frame51 = gtk_frame_new (NULL);
  gtk_widget_ref (frame51);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "frame51", frame51,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame51);
  gtk_box_pack_start (GTK_BOX (hbox24), frame51, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame51), GTK_SHADOW_NONE);

  hbox23 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox23);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "hbox23", hbox23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox23);
  gtk_box_pack_start (GTK_BOX (vbox20), hbox23, FALSE, TRUE, 0);

  frame50 = gtk_frame_new (NULL);
  gtk_widget_ref (frame50);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "frame50", frame50,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame50);
  gtk_box_pack_start (GTK_BOX (hbox23), frame50, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame50), GTK_SHADOW_NONE);

  ok_Template = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (ok_Template);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "ok_Template", ok_Template,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_Template);
  gtk_box_pack_start (GTK_BOX (hbox23), ok_Template, FALSE, FALSE, 3);

  cancel_template = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (cancel_template);
  gtk_object_set_data_full (GTK_OBJECT (template_selector), "cancel_template", cancel_template,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_template);
  gtk_box_pack_start (GTK_BOX (hbox23), cancel_template, FALSE, FALSE, 3);

  gtk_signal_connect (GTK_OBJECT (template_selector), "delete_event",
                      GTK_SIGNAL_FUNC (on_template_selector_delete_event),
                      v);
  gtk_signal_connect (GTK_OBJECT (templates), "select_icon",
                      GTK_SIGNAL_FUNC (on_templates_select_icon),
                      v);
  gtk_signal_connect (GTK_OBJECT (templates), "unselect_icon",
                      GTK_SIGNAL_FUNC (on_templates_unselect_icon),
                      v);
  gtk_signal_connect (GTK_OBJECT (about_template), "clicked",
                      GTK_SIGNAL_FUNC (on_about_template_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (ok_Template), "clicked",
                      GTK_SIGNAL_FUNC (on_ok_Template_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (cancel_template), "clicked",
                      GTK_SIGNAL_FUNC (on_cancel_template_clicked),
                      v);

  return template_selector;
}

static SelectTemplate *instance=NULL;

SelectTemplate::SelectTemplate() {
    shown=false;
    stream=NULL;
    this->widget = create_template_selector(this);
    _template=NULL;
}

SelectTemplate::~SelectTemplate() {
    instance=NULL;
}

SelectTemplate *SelectTemplate::getInstance() {
    if (instance == NULL) {
	instance=new SelectTemplate();
    }
    return instance;
}

void SelectTemplate::action(char *action) {
    if (!strcmp(action,"OK")) {
	if (_template!=NULL) {
	    _template->addObserver(this);
	    _template->build();
	}else{
            printf("--- NULL\n");
	}
    }
}

void SelectTemplate::notice(char *event, Subject *source) {
    if (!strcmp(event,TEMPLATE_BUILD_COMPLETE)) {
	stream=_template->getStream();
	_template->removeObserver(this);
	notify(SELECT_TEMPLATE_BUILD_COMPLETE);
        hide();
    }
}

void SelectTemplate::show() {
    if (!shown) {
	GnomeIconList *iconList=GNOME_ICON_LIST(lookup("templates"));

	slist<Template *> templates = get_video_templates();
	slist<Template *>::iterator iter;
	for (iter=templates.begin();iter!=templates.end();iter++) {
	    Template *t=*iter;
	    char **iconData=t->getIcon();
	    char *name=t->getName();
            GdkImlibImage *imlibIcon = gdk_imlib_create_image_from_xpm_data(iconData);
	    int pos=gnome_icon_list_append_imlib(iconList,imlibIcon,name);
            gnome_icon_list_set_icon_data(iconList,pos,t);
	}
	gtk_widget_show(widget);
        gtk_grab_add(widget);
        shown=true;
    }
}

void SelectTemplate::hide() {
    if (shown) {
        gtk_grab_remove(widget);
	gtk_widget_hide(widget);
	GnomeIconList *iconList=GNOME_ICON_LIST(lookup("templates"));
        gnome_icon_list_clear(iconList);
	shown=false;
        clear(); // Clear observers list
    }
}

ImStream *SelectTemplate::getStream() {
    return stream;
}

void SelectTemplate::setTemplate(int item) {
    if (item==-1) {
	_template=NULL;
    }else{
	GnomeIconList *iconList=GNOME_ICON_LIST(lookup("templates"));
	_template=(Template*)gnome_icon_list_get_icon_data(iconList,item);
    }
}
                                      
