// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include "seq_view.h"
#include "support.h"

static void
on_about_time_comp_image_stream1_activate
                                        (GtkMenuItem     *menuitem,
                                         SeqView         *sq)
{

}

static void
on_about_ganso1_activate
                                        (GtkMenuItem     *menuitem,
                                         SeqView         *sq)
{

}


static void
on_edit_compo_clicked                  (GtkButton       *button,
                                        SeqView         *sq)
{
    sq->action("EDIT");
}


static void
on_delete_compo_clicked                (GtkButton       *button,
                                        SeqView         *sq)
{

}


static void
on_insert_compo_clicked                (GtkButton       *button,
                                        SeqView         *sq)
{
    sq->action("INSERT");
}


static void
on_up_compo_clicked                    (GtkButton       *button,
                                        SeqView         *sq)
{

}


static void
on_down_compo_clicked                  (GtkButton       *button,
                                        SeqView         *sq)
{

}


static void
on_components_select_row               (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        SeqView         *sq)
{
    sq->setSelected(row);
}

static gboolean
on_sequential_image_delete_event       (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        SeqView         *sq)
{
    delete sq;
    return TRUE;
}

static void
on_filter_compo_clicked                (GtkButton       *button,
					SeqView         *sq)
{
    sq->action("FILTER");
}


static GnomeUIInfo help1_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("About Sequential Image Stream"),
    NULL,
    on_about_time_comp_image_stream1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType)0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("About GAnSO"),
    NULL,
    on_about_ganso1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_ABOUT,
    0, (GdkModifierType)0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo menubar2_uiinfo[] =
{
  {
    GNOME_APP_UI_SUBTREE, N_("Help"),
    NULL,
    help1_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType)0, NULL
  },
  GNOMEUIINFO_END
};

static GtkWidget*
create_sequential_image (SeqView *v)
{
  GtkWidget *sequential_image;
  GtkWidget *vbox7;
  GtkWidget *menubar2;
  GtkWidget *frame3;
  GtkWidget *hbox3;
  GtkWidget *frame13;
  GtkWidget *frame14;
  GtkWidget *vbox4;
  GtkWidget *toolbar2;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *edit_compo;
  GtkWidget *delete_compo;
  GtkWidget *insert_compo;
  GtkWidget *filter_compo;
  GtkWidget *up_compo;
  GtkWidget *down_compo;
  GtkWidget *scrolledwindow2;
  GtkWidget *components;
  GtkWidget *label4;
  GtkWidget *label5;
  GtkWidget *hbox4;
  GtkWidget *frame5;
  GtkWidget *frames_target;
  GtkWidget *statusbar2;

  sequential_image = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (sequential_image), "sequential_image", sequential_image);
  gtk_window_set_title (GTK_WINDOW (sequential_image), _("Sequential Image Streams"));

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox7);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "vbox7", vbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox7);
  gtk_container_add (GTK_CONTAINER (sequential_image), vbox7);

  menubar2 = gtk_menu_bar_new ();
  gtk_widget_ref (menubar2);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "menubar2", menubar2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar2);
  gtk_box_pack_start (GTK_BOX (vbox7), menubar2, FALSE, FALSE, 0);
  gnome_app_fill_menu (GTK_MENU_SHELL (menubar2), menubar2_uiinfo,
                       NULL, FALSE, 0);

  gtk_widget_ref (menubar2_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "help1",
                            menubar2_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "about_time_comp_image_stream1",
                            help1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "about_ganso1",
                            help1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  frame3 = gtk_frame_new (NULL);
  gtk_widget_ref (frame3);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "frame3", frame3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox7), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame3), GTK_SHADOW_NONE);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_container_add (GTK_CONTAINER (frame3), hbox3);

  frame13 = gtk_frame_new (_("Components"));
  gtk_widget_ref (frame13);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "frame13", frame13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame13);
  gtk_box_pack_start (GTK_BOX (hbox3), frame13, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame13), 5);

  frame14 = gtk_frame_new (NULL);
  gtk_widget_ref (frame14);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "frame14", frame14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame14);
  gtk_container_add (GTK_CONTAINER (frame13), frame14);
  gtk_container_set_border_width (GTK_CONTAINER (frame14), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frame14), GTK_SHADOW_NONE);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (frame14), vbox4);

  toolbar2 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar2);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "toolbar2", toolbar2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar2);
  gtk_box_pack_start (GTK_BOX (vbox4), toolbar2, FALSE, FALSE, 0);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar2), GTK_RELIEF_NONE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (sequential_image, GNOME_STOCK_PIXMAP_PROPERTIES);
  edit_compo = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Edit"),
                                _("Edit selected component"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (edit_compo);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "edit_compo", edit_compo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit_compo);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (sequential_image, GNOME_STOCK_PIXMAP_REMOVE);
  delete_compo = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Delete"),
                                _("Delete selected component"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (delete_compo);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "delete_compo", delete_compo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_compo);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (sequential_image, GNOME_STOCK_PIXMAP_ADD);
  insert_compo = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Insert"),
                                _("Insert after selected component"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (insert_compo);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "insert_compo", insert_compo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (insert_compo);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (sequential_image, GNOME_STOCK_PIXMAP_CONVERT);
  filter_compo = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Filter"),
                                _("Apply a filter to the selected stream"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (filter_compo);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "filter_compo", filter_compo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (filter_compo);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar2));

  tmp_toolbar_icon = gnome_stock_pixmap_widget (sequential_image, GNOME_STOCK_PIXMAP_TOP);
  up_compo = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Up"),
                                _("Move selected component up"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (up_compo);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "up_compo", up_compo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (up_compo);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (sequential_image, GNOME_STOCK_PIXMAP_BOTTOM);
  down_compo = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar2),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Down"),
                                _("Move selected component down"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (down_compo);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "down_compo", down_compo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (down_compo);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (vbox4), scrolledwindow2, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  components = gtk_clist_new (2);
  gtk_widget_ref (components);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "components", components,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (components);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), components);
  gtk_widget_set_usize (components, 160, -2);
  gtk_clist_set_column_width (GTK_CLIST (components), 0, 87);
  gtk_clist_set_column_width (GTK_CLIST (components), 1, 38);
  gtk_clist_column_titles_show (GTK_CLIST (components));

  label4 = gtk_label_new (_("Component"));
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_clist_set_column_widget (GTK_CLIST (components), 0, label4);

  label5 = gtk_label_new (_("padding"));
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_clist_set_column_widget (GTK_CLIST (components), 1, label5);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (hbox3), hbox4, TRUE, TRUE, 0);

  frame5 = gtk_frame_new (_("Frames"));
  gtk_widget_ref (frame5);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "frame5", frame5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame5);
  gtk_box_pack_start (GTK_BOX (hbox4), frame5, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame5), 5);

  frames_target = gtk_frame_new (NULL);
  gtk_widget_ref (frames_target);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "frames_target", frames_target,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frames_target);
  gtk_container_add (GTK_CONTAINER (frame5), frames_target);
  gtk_container_set_border_width (GTK_CONTAINER (frames_target), 5);
  gtk_frame_set_shadow_type (GTK_FRAME (frames_target), GTK_SHADOW_NONE);

  statusbar2 = gtk_statusbar_new ();
  gtk_widget_ref (statusbar2);
  gtk_object_set_data_full (GTK_OBJECT (sequential_image), "statusbar2", statusbar2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar2);
  gtk_box_pack_start (GTK_BOX (vbox7), statusbar2, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (sequential_image), "delete_event",
                      GTK_SIGNAL_FUNC (on_sequential_image_delete_event),
                      v);
  gtk_signal_connect (GTK_OBJECT (edit_compo), "clicked",
                      GTK_SIGNAL_FUNC (on_edit_compo_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (delete_compo), "clicked",
                      GTK_SIGNAL_FUNC (on_delete_compo_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (insert_compo), "clicked",
                      GTK_SIGNAL_FUNC (on_insert_compo_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (filter_compo), "clicked",
                      GTK_SIGNAL_FUNC (on_filter_compo_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (up_compo), "clicked",
                      GTK_SIGNAL_FUNC (on_up_compo_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (down_compo), "clicked",
                      GTK_SIGNAL_FUNC (on_down_compo_clicked),
                      v);
  gtk_signal_connect (GTK_OBJECT (components), "select_row",
                      GTK_SIGNAL_FUNC (on_components_select_row),
                      v);

  return sequential_image;
}


void SeqView::show() {
    widget=create_sequential_image(this);
    gtk_widget_show(widget);
    selected=-1;
    updateStreams();
}

void SeqView::noticeMore(char *event, Subject *source) {
}

void SeqView::clearVisualList() {
    GtkCList *components=GTK_CLIST(lookup("components"));
    gtk_clist_clear(components);
}

void SeqView::updateOneStream(ImStream *s) {
    SeqImStream *domain=(SeqImStream *)stream;
    GtkCList *components=GTK_CLIST(lookup("components"));
    char *text[2];
    char buffer[128];
    text[0]=s->getName();
    snprintf(buffer,127,"%d",((SeqImStream*)domain)->paddingOf(s));
    text[1]=buffer;
    gtk_clist_append(components,text);
}


void SeqView::action(char *action) {
    if (!strcmp(action,"EDIT")) {
	editCurrent();
    }else if (!strcmp(action,"INSERT")){
	buildNewStream();
    }else if (!strcmp(action,"FILTER")){
        filterCurrent();
    }
}

Prototype *SeqView::clone() {
    return new SeqView();
}
