// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef __TREE_VISITOR_H__
#define __TREE_VISITOR_H__

#include <view.h>
#include <imstreamvisitor.h>
#include <gnome_tree.h>

typedef slist<ImStream*> StreamList;

class TreeVisitor: public ImStreamVisitor {
    GnomeTree *tree;
    GtkTree *gtktree;
    void visitComposite(CompImStream *domain);
    bool findStream(StreamList *list, ImStream *stream);
    bool findTree(TreeList *list, ImStream *stream);
    void compare(StreamList &domain, StreamList &newS, TreeList &oldS);
public:
    TreeVisitor(GnomeTree *tree);
    TreeVisitor(GtkTree *tree);

    GnomeTree *getTree() { return tree; }

    void visitFileImStream(FileImStream *s);
    void visitSeqImStream(SeqImStream *s);
    void visitConcurrentImStream(ConcurrentImStream *s);
    void visitFilterImStream(FilterImStream *s);
};

#endif
