// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <stdlib.h>
#include "image.h"
#include <iostream.h>
#include <stdio.h>

Image::Image(unsigned width, unsigned height) {
    unsigned i;
    
    this->_width=width;
    this->_height=height;

    data=(Pixel **)malloc(_height*sizeof(Pixel*));

    Pixel *raw=(Pixel *)calloc(_width*_height,sizeof(Pixel));

    for (i=0;i<_height;i++) {
	data[i]=raw + _width*i;
    }
}

Image::~Image() {
    free(data[0]);
    free(data);
}


void Image::putPixel(int x, int y, byte r, byte g, byte b) {
    if (x<0 || x>=(int)_width || y<0 || y>=(int)_height) return;
    Pixel *p=data[y]+x;
    p->r=r;
    p->g=g;
    p->b=b;
}

void Image::getPixel(int x, int y, byte *r, byte *g, byte *b) {
    if (x<0 || x>=(int)_width || y<0 || y>=(int)_height) return;
    Pixel *p=data[y]+x;
    *r=p->r;
    *g=p->g;
    *b=p->b;
}

#define MAX(a,b) ((a)>(b)?(a):(b))

void Image::copy(Image *target, int ofs_x, int ofs_y) {
    unsigned x,y;
    unsigned w,h;
    Pixel *targetbuff=target->frameBuffer()+ofs_y*target->width()+ofs_x;
    w=target->width();
    h=target->height();
    if (_width<w) w=_width;
    if (_height<h) h=_height;
    for (y=0;y<h;y++)
    {
	Pixel *row=data[y];
	Pixel *trow=targetbuff;
	for (x=0;x<w;x++)
	{
	    int r=row->r;
	    int g=row->g;
	    int b=row->b;
            int a=row->a;
	    int t_r=trow->r;
	    int t_g=trow->g;
	    int t_b=trow->b;
	    int endAlpha=MAX(a,trow->a);

            trow->r=(a*(r - t_r) + (t_r << 8))>>8;
            trow->g=(a*(g - t_g) + (t_g << 8))>>8;
            trow->b=(a*(b - t_b) + (t_b << 8))>>8;
	    trow->a=endAlpha;
	    row++;
	    trow++;
	}
	targetbuff+=target->width();
    }
}
