// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef __IMAGE_H__
#define __IMAGE_H__

typedef unsigned char byte;

typedef struct{
    byte r, g, b, a; /* RED, GREEN, BLUE, ALPHA */
} Pixel;

class Image {
private:
    Pixel **data;
    unsigned _width, _height;
public:
    Image(unsigned width, unsigned height);
    ~Image();
    void putPixel(int x, int y, byte r, byte g, byte b);
    void getPixel(int x, int y, byte *r, byte *g, byte *b);
    Pixel *frameBuffer() {return data[0];}
    unsigned width() { return _width; }
    unsigned height() { return _height; }
    void copy(Image *target, int ofs_x, int ofs_y);
};

#endif
