// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/**
 * IMAGE STREAM
 */
#ifndef __IMSTREAM_H__
#define __IMSTREAM_H__

#include <image.h>
#include <subject.h>
#include <string.h>

class ImStreamVisitor; // Avoid recursive includes

typedef enum {
    SSEEK_SET, // The offset is set to offset bytes.
    SSEEK_CUR  // The offset is set to its current location plus offset bytes.
} SeekType;

class ImStream: public Subject {
    char *name;
public:
    ImStream               (char *name) {this->name=strdup(name);}
    virtual void nextImage (Image *buffer)=0;
    virtual void rewind    ()=0;
    virtual void seek      (int offset, SeekType type)=0;
    virtual int  size      ()=0;
    virtual ~ImStream      () {}
    char* getName          () { return name; }
    void  setName          (const char *name) { this->name=strdup(name); }
    
    virtual void accept(ImStreamVisitor *visitor)=0;
};


#endif
