// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "seqimstream.h"
#include <imstreamvisitor.h>

SeqImStream::SeqImStream(char *name):CompImStream(name) {
    current_padding=0;
    current_position=0;
    current=NULL;
}

#include <stdio.h>

void SeqImStream::nextImage (Image *buffer) {
    if ( current_padding > 0 ) {
	current_padding--;
    }else{
	if (current!=streams.end())
	{
	    ImStream *cur=*current;
	    if ( current_position < cur->size() ) {
		current_position++;
		cur->nextImage(buffer);
	    }else{
		current++;
		currentp++;
		current_position=0;
                if (current!=streams.end())
		    current_padding=*currentp;
		nextImage(buffer);
	    }
	}
    }
}

void SeqImStream::seek (int offset, SeekType type) {
    switch (type) {
    case SSEEK_SET:
	rewind();seek(offset,SSEEK_CUR);
	break;
    case SSEEK_CUR:
	int left=offset;
	while (left>0 && current!=streams.end()) {
	    current_padding-=left;
	    if (current_padding<0) {
		left=-current_padding;
		current_padding=0;
	    }else{
		left=0;
	    }
	    current_position+=left;
	    ImStream *cur=*current;
	    if (current_position >= cur->size()) {
		left=(current_position - cur->size());
		current_position=0;
		current++;
                currentp++;
                if (current!=streams.end())
		    current_padding=*currentp;
	    }else{
		left=0;
	    }
	}
	break;
    }
}

int SeqImStream::size () {
    int total=0;
    slist<ImStream*>::iterator iter;
    slist<int>::iterator iterp;
    for (iter=streams.begin(), iterp=paddings.begin();
	 iter!=streams.end();iter++, iterp++)
    {
	ImStream *stream=*iter;
	int padd=*iterp;
	total+=stream->size()+padd;
    }
    return total;
}

void SeqImStream::append(ImStream *stream, int padding) {
    streams.insert(streams.end(), stream);
    paddings.insert(paddings.end(), padding);
    if (current==NULL) {
	current=streams.begin();
	currentp=paddings.begin();
	current_padding=*currentp;
    }
    notify("STREAM_LIST_MODIFIED");
}

int SeqImStream::paddingOf(ImStream *stream) {
    slist<ImStream*>::iterator iter;
    slist<int>::iterator iterp;
    for (iter=streams.begin(), iterp=paddings.begin();
	 iter!=streams.end();iter++, iterp++) {
	ImStream *_stream=*iter;
	if (_stream==stream) {
	    return *iterp;
	}
    }
    return -1;
}

void SeqImStream::accept(ImStreamVisitor *visitor) {
    visitor->visitSeqImStream(this);
}

void SeqImStream::append(ImStream *stream) {
    int padding=0;
    streams.insert(streams.end(), stream);
    paddings.insert(paddings.end(), padding);
    if (current==NULL) {
	current=streams.begin();
	currentp=paddings.begin();
	current_padding=*currentp;
    }
    notify(COMP_APPEND);
}

void SeqImStream::rewind() {
    rewindAll();
    current_position=0;
    current=streams.begin();
    currentp=paddings.begin();
    if (current!=streams.end())
	current_padding=*currentp;
}
