// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <typeinfo>

#include "streameditor.h"

struct eqtypes
{
    bool operator()(char *s1, char *s2) const
    {
        return (strcmp(s1,s2)==0);
    }
};


StreamEditor::StreamEditor() {
    stream=NULL;
}

void StreamEditor::setStream(ImStream *stream) {
    if (this->stream) {
	this->stream->removeObserver(this);
    }
    this->stream=stream;
    stream->addObserver(this);
    show();
}

static hash_map<char*, StreamEditor*, hash<char*>, eqtypes> editors;

void register_stream_editor(ImStream *stream_example, StreamEditor *editor) {
    char *n=strdup(typeid(*stream_example).name());
    editors[n]=editor;
}

StreamEditor *get_stream_editor(ImStream *stream) {
    char *n=(char*)typeid(*stream).name();
    if (editors.find(n)!=editors.end()) {
	StreamEditor *se=(StreamEditor*)(editors[n])->clone();
	se->setStream(stream);
	return se;
    }else{
	return NULL;
    }
}

StreamEditor::~StreamEditor() {
    stream->removeObserver(this);
}
