// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef __STREAM_EDITOR_H__
#define __STREAM_EDITOR_H__

#include <prototype.h>
#include <typeinfo>
#include <hash_map.h>
#include <imstream.h>
#include <view.h>

class StreamEditor: public View, public Prototype {
protected:
    ImStream *stream;
public:
    StreamEditor();
    virtual ~StreamEditor();
    void setStream(ImStream *stream);
    virtual void show()=0;
    virtual void notice(char *event, Subject *source)=0;
    virtual void action(char *action)=0;
    virtual Prototype *clone()=0;
};

/* This function allows modules to register their editors */
extern void register_stream_editor(ImStream *stream_example, StreamEditor *editor);

/* This function allows the program to find the editor suitable for a stream */
StreamEditor *get_stream_editor(ImStream *stream);


#endif
