// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef __TEMPLATE_H__
#define __TEMPLATE_H__

#define TEMPLATE_BUILD_COMPLETE "TEMBCOMP"

#include <imstream.h>
#include <subject.h>

class Template: public Subject {
public:
    virtual ~Template();
    virtual char ** getIcon()=0;

    // Mandatory Information
    virtual char *getName()=0;
    virtual char *getVersion()=0;
    virtual char *getCopyright()=0;
    virtual char **getAuthors()=0;

    // Optional information
    virtual char *getDescription() { return ""; }

    virtual void build()=0;

    // Stream getting
    virtual ImStream *getStream()=0;
};

/* This function allows modules to register their templates */
void register_video_template(Template *t);

/* This function allows the program to see the registered templates */
slist<Template *> get_video_templates();


#endif
