// GAnSO - GNOME Animation StudiO
// Copyright (C) 2000 Ruben Lopez Gomez
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <slist.h>
#include <videoloader.h>
#include <view.h>

static slist<VideoLoader *> loaders;

void register_video_loader(VideoLoader *loader) {
    loaders.insert(loaders.end(),loader);
}

slist<VideoLoader *> get_video_loaders() {
    return loaders;
}

VideoLoader *find_video_loader(char *filename) {
    slist<VideoLoader *>::iterator iter;
    for (iter = loaders.begin(); iter != loaders.end(); iter++) {
	VideoLoader *loader = *iter;
	if (loader->canLoad(filename)) {
	    VideoLoader *result = (VideoLoader *)loader->clone();
	    result->setFileName(filename);
	    return result;
	}
    }
    return NULL; // sorry, unknown file format
}
